DECLARE SUB particlerain ()
DECLARE SUB particlesnow ()
DECLARE SUB particleweather ()
declare sub ParticlePurge ()
declare FUNCTION ParticleActiveNumber% ()
declare SUB ParticleClip ()
declare sub ParticleRender ()
declare SUB ParticleRandomGenerator (colr%, ParticleType%)
declare SUB ParticleBehave ()

CONST particle.transparant = -1
CONST MaxActiveParticles = 1500



TYPE particle
 x AS INTEGER
 y AS INTEGER
 active AS INTEGER
 colour AS INTEGER '-1 will be transparant
 behaviour AS INTEGER
 life AS INTEGER
END TYPE

DIM SHARED particles(1 TO MaxActiveParticles) AS particle


SUB particlerain ()
		ParticleRandomGenerator -1, 2
		ParticleBehave
		ParticleClip
		ParticleRender 

END SUB

SUB particlesnow ()

		ParticleRandomGenerator 31, 1
		ParticleBehave
		ParticleClip
		ParticleRender 

END SUB

SUB particleweather ()
SELECT CASE weather
 CASE 1
  particlerain 
 CASE 2
  particlesnow
 CASE ELSE
		'This is here so remaining snow or rain
		'won't stick to the screen.
		ParticleBehave
		ParticleClip
		ParticleRender 
END SELECT
END SUB
sub ParticlePurge()
   FOR a = 1 TO MaxActiveParticles
 IF particles(a).active THEN particles(a).active = 0
NEXT a
end sub

FUNCTION ParticleActiveNumber% ()
b = 0
FOR a = 1 TO MaxActiveParticles
 IF particles(a).active THEN b = b + 1
NEXT a
ParticleActiveNumber% = b
END FUNCTION

SUB ParticleBehave ()
 FOR a = 1 TO MaxActiveParticles
  IF particles(a).active THEN
   SELECT CASE particles(a).behaviour
    CASE 1
     particles(a).y = particles(a).y + 2
     particles(a).life = particles(a).life - 3
    CASE 2
     particles(a).y = particles(a).y + 3
     particles(a).life = particles(a).life - 4
    CASE 3
     particles(a).y = particles(a).y + 3
     particles(a).x = particles(a).x + 1
     particles(a).life = particles(a).life - 4
    CASE 4
     particles(a).y = particles(a).y + 3
     particles(a).x = particles(a).x - 1
     particles(a).life = particles(a).life - 4
    CASE ELSE
     particles(a).life = particles(a).life - 1

   END SELECT
  END IF


 NEXT a

END SUB

SUB ParticleClip ()
FOR a = 1 TO MaxActiveParticles
 IF particles(a).active = 1 THEN
  IF (particles(a).x < 0) OR (particles(a).x > 320) OR (particles(a).y < 0) OR (particles(a).y > 240) THEN 'FIXME:change to 240 in the actual engine!
   particles(a).active = 0
  END IF
  IF particles(a).life <= 0 THEN particles(a).active = 0
 END IF
NEXT a
END SUB

DEFSNG A-Z
FUNCTION ParticleGetFree% ()
 x = 1
 WHILE (particles(x).active = 1) AND x < MaxActiveParticles: x = x + 1: WEND
 ParticleGetFree% = x
END FUNCTION

DEFINT A-Z
SUB ParticleRandomGenerator (colr%, ParticleType%)
    SELECT CASE ParticleType%
    CASE 1
        a = ParticleGetFree()
        particles(a).x = INT(RND(1) * 320)
        particles(a).y = INT(RND(1) * 10)
        particles(a).active = 1
        particles(a).colour = colr%'INT(RND(1) * 255)
        particles(a).behaviour = INT(RND(1) * 4) + 1
        particles(a).life = INT(RND(1) * 200) + 120

        b = ParticleGetFree()
        particles(b).x = particles(a).x
        particles(b).y = particles(a).y - 1
        particles(b).active = 1
        particles(b).colour = colr%
        particles(b).behaviour = particles(a).behaviour
        particles(b).life = particles(a).life
    CASE 2
        a = ParticleGetFree()
        particles(a).x = INT(RND(1) * 320)
        particles(a).y = INT(RND(1) * 10)
        particles(a).active = 1
        particles(a).colour = colr%'INT(RND(1) * 255)
        particles(a).behaviour = INT(RND(1) * 2) + 1
        particles(a).life = INT(RND(1) * 200) + 120

        b = ParticleGetFree()
        particles(b).x = particles(a).x
        particles(b).y = particles(a).y - 1
        particles(b).active = 1
        particles(b).colour = colr%
        particles(b).behaviour = particles(a).behaviour
        particles(b).life = particles(a).life


    END SELECT
                               
END SUB

SUB ParticleRender ()
 FOR a = 1 TO MaxActiveParticles
  IF particles(a).active THEN
    putd particles(a).x, particles(a).y, particles(a).colour
  END IF
 NEXT a

END SUB

