'Quest for a King for Win32 and Linux
'Version 1.5

const tilde = 96
const LetMeDebug = 0

Dim shared NightFall

declare sub PaletteOverlay


'$include:'music.bi'
'$include:'omalib.bi'

'$include:'startup.bi'
'$include:'particle.bi'
'$include:'console.bi'



DEFINT A-Z


omaSDL_Init ()
SDL_WM_SetCaption "Quest for a King",0
omaSetFramesPerSecond 60
getpal()
BackBitmap = omaLoadMaskedGraphic ("data/back2x.bmp")
SpriteBitmap = omaLoadMaskedGraphic ("data/spr2x.bmp")
Music% = winmmInitMidi

Script 0    'The autoexec.bat, if you will.
DIM oldtimer2 AS DOUBLE
DIM fps AS INTEGER
IF COMMAND$ = "-NOVSYNC" THEN novsync = 1

DO
   
   frames = frames + 1
   
   
	IF TIMER - oldtimer2 > 1 THEN
      fps = frames \ (TIMER - oldtimer2)
      frames = 0
      oldtimer2 = TIMER
   END IF
   
	reimplemented = 1
   
   MoveWater
   MoveTransition
   loope = 0 'Animates the moving water.
	ProgramErrorMessage = "Main Loop"
	'Control and AI.
   
   objects(1, 10) = 1
   
   particleweather ()
   
	'checks to see what the objects should be doing.
   objectbehave
   ParticleBehave
   'does the keyboard control checks.
   nControl
   
   
	'Rendering Routines
   
   calcrenderarea
   drawall        'Draws everything on the screenSurfaces background.
   renderobjects  'Draws the objects (people & stuff)
   particleRender
   particleWeather
   
   pageflip       'Flip the video page.
   
LOOP

10        'My error recovery routine.
'multikey -2, x
'screenSurface 13: screenSurface 0: WIDTH 80
addToDebug "Error."

sleep
omaQuit () 





SUB addToDebug (text AS STRING)
   if LetMeDebug = 1 then print text
   
END SUB

SUB AniSequence (x, y, MiniX, MiniY, startframe, endframe)
	HealSpriteNumber = FreeSprite()
	objects(HealSpriteNumber, 1) = x
	objects(HealSpriteNumber, 2) = y
	objects(HealSpriteNumber, 4) = MiniX'objects(players(x).sprite, 4)
	objects(HealSpriteNumber, 5) = MiniY'objects(players(x).sprite, 5)
   
   
   
	FOR Healsprite = startframe TO endframe
      
      objects(HealSpriteNumber, 3) = Healsprite
      
      fullredraw
      pageflip
      
      pwait .1
      
   NEXT Healsprite
   
   FOR h = 1 TO 5
      fullredraw
      pageflip
      
      objects(HealSpriteNumber, h) = 0
   NEXT h
   
END SUB

SUB battle (Result)
   addtodebug "In the battle system!"
   DataGet 
   
   DIM a AS INTEGER
   DIM colorgrid(1 TO 3, 1 TO 4) AS INTEGER
   
   DIM button(4) AS INTEGER
   
   battleX = 1
   battley = 1
   addToDebug "Inited, Checking who is alive."
   IF players(1).dead = False THEN players(1).ready = 1'This serves a dual purpose -- the initilization
   'of the code, and making sure players realize they're in a battle.
   'accidents, capice?
   DO
      addToDebug "Checking enemy stats"
      FOR a = 1 TO 3
         IF enemies(a).exists = True AND enemies(a).hp > 0 THEN
            enemies(a).time = enemies(a).time + 1
            IF enemies(a).time > enemies(a).speed THEN
               enemies(a).time = 0
               EnemyAttack a
            END IF
         END IF
      NEXT a
      addToDebug "Checking player stats"
      FOR a = 1 TO 3
         IF players(a).exists = True AND players(a).dead = False THEN
            
            players(a).time = players(a).time + 1
            IF players(a).time > 100 THEN
               IF WaitForReadyPlayer = True THEN
                  battleX = a
                  WaitForReadyPlayer = False
               END IF
               players(a).time = players(a).speed
               
               players(a).ready = True
            END IF
         END IF
      NEXT a
      addToDebug "Checking Keyboard Controls"
      GOSUB KeyboardControls
      addToDebug "Checking for dead folks"
      GOSUB Checkdead
      addToDebug "Checking for dead folks...again"
      IF players(1).dead = False THEN
         objects%(139, 1) = objects%(players(1).sprite, 1)
         objects%(139, 2) = objects%(players(1).sprite, 2)
         objects%(139, 3) = 44
         objects%(139, 4) = objects%(players(1).sprite, 4)
         objects%(139, 5) = objects%(players(1).sprite, 5)
         
      END IF
      addToDebug "about to activate the reimplement Flag" 
      reimplemented = 1
      addToDebug "About to do a Full Redraw"
      fullredraw
      addToDebug "About to draw a BattleBox"
	   
      battlebox
	   
      
      '    IF players(1).ready = true THEN GOSUB PlayeroneInterface
      '    IF players(2).ready = true THEN GOSUB PlayertwoInterface
      '    IF players(3).ready = true THEN GOSUB PlayerThreeInterface
      
      
      addToDebug "About to draw the states"
      GOSUB statsinterface
      addToDebug "About to begin colour checks"
      'There is no real reson that this shouldn't exist.
      FOR osss = 1 TO 0 STEP -1
         FOR a = 1 TO 3
            FOR b = 1 TO 4
               colorgrid(a, b) = 31 * ABS(osss - 1)
            NEXT b
            IF players(a).dead = 1 THEN players(a).ready = 0
            IF players(a).dead = 1 THEN objects(players(a).sprite, 3) = 0
         NEXT a
         colorgrid(battleX, battley) = BattleCursorColor * ABS(osss - 1)
         
         shadowdrop = osss
         addToDebug "About to draw the menu"
         FOR xyz = 1 TO 3
            IF players(xyz).exists = True THEN
               IF players(xyz).ready = True THEN
                  xsprint 180, (75 * (xyz - 1)), "Attack", colorgrid(xyz, 1)
                  xsprint 192, (75 * (xyz - 1)), "Defend", colorgrid(xyz, 2)
                  xsprint 204, (75 * (xyz - 1)), "Magic", colorgrid(xyz, 3)
                  xsprint 216, (75 * (xyz - 1)), "Item", colorgrid(xyz, 4)
               END IF
               
               
               xsprint 168, (75 * (xyz - 1)), players(xyz).sname, 2 * ABS(osss - 1)
               
               xsprint 228, (75 * (xyz - 1)), LTRIM$(RTRIM$(STR$(players(xyz).hp) + "/" + STR$(players(xyz).maxhp))), 2 * ABS(osss - 1)
            END IF
         NEXT xyz
      NEXT osss
      pageflip
      reimplemented = 0
      
      
   LOOP
   
   EXIT SUB
   statsinterface:
   
   FOR drpshd = 1 TO 0 STEP -1
      shadowdrop = drpshd
      
      FOR Z = 1 TO 3
         IF players(Z).exists = True THEN
            IF players(Z).ready = True THEN
               xsprint 192 + (12 * (Z - 1)), 220, "M:" + LTRIM$(RTRIM$(STR$(players(Z).mp) + "/" + STR$(players(1).maxmp))), 2 * ABS(drpshd - 1)
            ELSE
               drawgraph 220, 192 + (12 * (Z - 1)), 90, 100, players(Z).time, 16, 2 * ABS(drpshd - 1)
               
            END IF
         END IF
      NEXT Z
   NEXT drpshd
   
   RETURN
   
   KeyboardControls:
   
   
   keycode = 0
   KeyCode = GetSingleKey
   
   'this is just a hack to make it work, but it's a hack which will do the trick.
   
   
   
   
   
   IF keycode = oldkeycode% THEN
      
      
      resetcode = 1
   END IF
   oldkeycode% = keycode%
   
   IF resetcode = 1 THEN keycode% = 0: resetcode = 0
   
   
   SELECT CASE keycode%
   CASE rarrow
		'I have to use ugly code here. I'm really ashamed. really.
		IF battleX = 1 THEN
			IF players(2).ready = True THEN
				battleX = 2
         ELSEIF players(3).ready = True THEN
				battleX = 3
         ELSE
				battleX = 1
         END IF
      ELSEIF battleX = 2 THEN
			IF players(3).ready = True THEN battleX = 3
      END IF
	   
   CASE larrow
		IF battleX = 3 THEN
			IF players(2).ready = True THEN
				battleX = 2
         ELSEIF players(1).ready = True THEN
            battleX = 1
         ELSE
            battleX = 3
         END IF
      ELSEIF battleX = 2 THEN
			IF players(1).ready = True THEN battleX = 1
      END IF
      
   CASE Uparrow 'The up and down arrows are horrible too...
		battley = battley - 1
		IF battley = 0 THEN battley = 1
   CASE Dnarrow
      battley = battley + 1
      IF battley = 5 THEN battley = 4
   CASE Spacebar
      IF players(battleX).ready = True THEN
         players(battleX).ready = False
         FOR a = 1 TO 3
            IF players(a).exists = True AND players(a).dead = False THEN
               
               players(a).time = players(a).time + 1
               IF players(a).time > 100 THEN
                  IF WaitForReadyPlayer = True THEN
                     battleX = a
                     WaitForReadyPlayer = False
                  END IF
                  players(a).time = players(a).speed
                  
                  players(a).ready = True
               END IF
            END IF
         NEXT a
         
         SELECT CASE battley
         CASE 1
            PlayerAttack (battleX)
            IF players(battleX).time = 0 THEN
               players(battleX).ready = False
            END IF
            
				WaitForReadyPlayer = True
				FOR a = 1 TO 3
					IF players(a).ready = True THEN
						battleX = a
						WaitForReadyPlayer = False
						a = 4
               END IF
            NEXT a
         CASE 2
            players(battleX).ready = False
            players(battleX).time = 0
            playerdefendadd = Healthadd(battleX, players(battleX).maxhp * .15)'15% rather than playerhealth / 15
            'players(battlex).hp = players(battlex).hp + playerdefendadd
            
				fullredraw
				PrintOnObject players(x%).sprite, STR$(playerdefendadd), 2
            
				battlebox
				pageflip
				pwait (.5)
            
				WaitForReadyPlayer = True
				FOR a = 1 TO 3
					IF players(a).ready = True THEN
						battleX = a
						WaitForReadyPlayer = False
						a = 4
               END IF
            NEXT a
            
         CASE 3
            'WHOO HOO! MAGIC MENU! LALALALALA!
            IF chooseSpell(battleX) = 1 THEN
				   players(battleX).ready = False
				   players(battleX).time = 0
               
               WaitForReadyPlayer = True
               FOR a = 1 TO 3
                  IF players(a).ready = True THEN
                     battleX = a
                     WaitForReadyPlayer = False
                     a = 4
                  END IF
               NEXT a
            END IF
         CASE 4
            'WHOO HOO! ITEM MENU! Oddly enough, installed on a tuesday!
            res = 0
            chooseItem (res)
            IF res = 0 THEN
               players(battleX).ready = False
               players(battleX).time = 0
               
               WaitForReadyPlayer = True
               FOR a = 1 TO 3
                  IF players(a).ready = True THEN
                     battleX = a
                     WaitForReadyPlayer = False
                     a = 4
                  END IF
               NEXT a
            END IF
            
            
         END SELECT
      END IF
   CASE Esc 'You want to quit the game during battle? LOSE.
      
      
   END SELECT
	flippedpvpvary% = -pvpvary
	flippedpvpvarx% = -pvpvarx
   
   calcrenderarea
   drawall
   'IF ObjectShadows = 1 THEN RenderObjectShadows
   renderobjects
   particleweather 
   
   RETURN
   Checkdead:
   numberofdead = 0
   FOR a = 1 TO 3
      IF players(a).dead = True OR players(a).exists = False THEN numberofdead = numberofdead + 1
   NEXT a
   IF numberofdead = 3 THEN
		Result% = 0
		fullredraw
		battlebox
		sprint 16, "Lost...", 1
		pageflip
		ctrlslp
		IF SupposedToDie = False THEN
         
			'instead of exiting the program (which is stupid now),
			'I clear the screen and display the start menu.
         
         deinit
      END IF
      EXIT SUB
   END IF
   
   numberofdead = 0
   FOR a = 1 TO 3
      IF enemies(a).exists = False THEN
         numberofdead = numberofdead + 1
         IF enemies(a).sprite <> 0 THEN objects(enemies(a).sprite, 3) = 0
      END IF
   NEXT a
   
   IF numberofdead = 3 THEN
		Result% = 1
      calcrenderarea
		drawall
      '     IF ObjectShadows = 1 THEN RenderObjectShadows
		renderobjects
		particleweather 
      
		battlebox
		sprint 14, "Victory!", 1
		pageflip
		ctrlslp
		drawall
      '  IF ObjectShadows = 1 THEN RenderObjectShadows
		renderobjects
		particleweather 
      
		battlebox
		FOR a = 1 TO 3
			texperience = texperience + enemies(a).iexp
      NEXT a
		sprint 16, STR$(texperience) + " Experience gained!", 1
		pageflip
		ctrlslp
		FOR a% = 1 TO 3
         IF players(a%).dead = 0 THEN
			   olev = players(a%).level
			   players(a%).Experience = players(a%).Experience + (texperience)
			   PlayersCalculate players()
            IF players(a%).level > olev THEN
               drawall
               '   IF ObjectShadows = 1 THEN RenderObjectShadows
               renderobjects
               particleweather 
               
               battlebox
               sprint 16, LTRIM$(RTRIM$(players(a%).sname)) + " Gained a level!", 1
               
               
               pageflip
               ctrlslp
            END IF
         END IF
      NEXT a%
		objects%(139, 1) = 0
		objects%(139, 2) = 0
		objects%(139, 3) = 0
      
      EXIT SUB
   END IF
   RETURN
END SUB

SUB battlebox ()
   dim w, h
 omaGetScreenDimensions w, h 

   transbox 1, (w/2), (h / 4) + 40, (h/2)
END SUB

FUNCTION battlescript (playa AS INTEGER, attackno AS INTEGER)
   DIM nam AS STRING
   nam = players(playa).sname
   nam = LCASE$(LTRIM$(RTRIM$(nam)))
   'nam2 = nam
   
   DIM lin AS STRING
   
   DIM this AS INTEGER
   DIM SpareSprite AS INTEGER
   
   SpareSprite = FreeSprite
   atkno = attackno
   CodePointer = 0
   
   WHILE (LTRIM$(RTRIM$(LCASE$(lin))) <> nam) AND (GetParameter(lin, 1) <> "attack") AND (lin <> "Out of Bounds") AND (GetParameter$(lin, 1) <> "end")
      CodePointer = CodePointer + 1
      
      cp = CodePointer
      lin = LTRIM$(RTRIM$(LCASE$(ReadLine(playa, atkno, CodePointer))))
      
      ' these lines of code work in one way; they keep the value constant.
      CodePointer = cp
      atkno = attackno ' this a hopeful hack -- will it work? I dunno
      
      SELECT CASE GetParameter$(lin, 1)
      CASE "aquiretarget"
         this = INT(PlayerTargetSelect)
         IF this = 0 THEN battlescript = 0: EXIT FUNCTION
      CASE "gethealtarget"
         HealingTargetSelect objects(), players(), this
         IF this = 0 THEN
            battlescript = 0
            EXIT FUNCTION
         END IF
      CASE "healthis"
         
         
         PrintOnObject players(this).sprite, STR$(Healthadd(this, players(playa).attack / (RND(1) * 2))), 2
         statsint
         keycontrol 0
         
         renderbattlemenu
         
         
         players(this).hp = players(this).hp + Healthadd(this, players(playa).attack / (RND(1) * 2))
         
         showpage (page)
      CASE "pause"
         
         pwait (.5)
         
         
      CASE "hurtthis"
         
         'This beauty is the attack power.
         attacks = players(playa).attack + (players(playa).attack * RND(1) * 2)
         attacks = INT(attacks)
         
         'If the attack will kill the player, it changes the attack to the HP.
         IF attacks < enemies(this).defence THEN miss = 1 ELSE miss = 0
         
         IF miss = 1 THEN
            PrintOnObject enemies(this).sprite, "Missed", 31
            statsint
            keycontrol 0
            
            renderbattlemenu
            
            showpage (page)
         ELSE
            statsint
            keycontrol 0
            
            renderbattlemenu
            
            attacks = attacks - enemies(this).defence
            IF attacks > enemies(this).hp THEN
               attacks = 0
               enemies(this).hp = 0
               enemies(this).exists = False
            ELSE
               
               enemies(this).hp = enemies(this).hp - attacks
               
               
            END IF
         END IF
         
         PrintOnObject enemies(this).sprite, STR$(attacks), 31
         statsint
         keycontrol 0
         
         renderbattlemenu
         
         showpage (page)
      CASE "linemove"
         
         linemove CINT(a), enemies(target).sprite, 15
      CASE "flash"
         
         W = VAL(GetParameter$(lin, 2))
         x = VAL(GetParameter$(lin, 3))
         y = VAL(GetParameter$(lin, 4))
         Z = VAL(GetParameter$(lin, 5))
         fullredraw
         battlebox
         
         
         
         statsint
         keycontrol 0
         
         renderbattlemenu
         pageflip
         
         pscroll W, x, y, Z
         pscroll -W, -x, -y, Z
      CASE "newscreenSurface"
         
         fullredraw
         battlebox
         statsint
         renderbattlemenu
         
         '               Pageflip
         
      CASE "drainmana"
         players(playa).mp = players(playa).mp - VAL(GetParameter$(lin, 2))
      CASE "prerequisite"
         IF players(playa).mp < VAL(GetParameter$(lin, 2)) THEN
            battlescript = 0
            EXIT FUNCTION
         END IF
      CASE "spriteonplayer"
         objects(SpareSprite, 1) = objects(players(playa).sprite, 1)
         objects(SpareSprite, 2) = objects(players(playa).sprite, 2)
         
         objects(SpareSprite, 4) = objects(players(playa).sprite, 4)
         objects(SpareSprite, 5) = objects(players(playa).sprite, 5)
         
      CASE "setsparespritenumber"
         objects(SpareSprite, 3) = VAL(GetParameter(lin, 2))
         
      CASE "sparespritegoto"
         th = this
         Linegoto SpareSprite, enemies(this).sprite, 10
         this = th
      END SELECT
      
   WEND
   
   FOR a = 1 TO 7
      objects(SpareSprite, a) = 0
   NEXT a
   
   battlescript = 1
END FUNCTION

FUNCTION BinaryArray (x, y) 'Y is the boolean array. X is the num.
   'IF x = 0 THEN BinaryArray = 0: EXIT FUNCTION
   DIM optimizednumber AS INTEGER
   x -= 1
   optimizednumber = 1 shl x
   'optimizednumber = 2 ^ (x - 1)'base2nums(x)
   BinaryArray = (optimizednumber AND y) <> 0
   
END FUNCTION

SUB bpwait (a, target, S$)
   oldtimer = SDL_GetTicks () + (a! * 1000)
   WHILE oldtimer + b > TIMER
      
		fullredraw
		PrintOnObject target, S$, 31
      
		battlebox
		Drawbattlemenu
      
		pageflip
      
      
   WEND
   
END SUB

SUB calcrenderarea ()
   STATIC oldpvpvary
   STATIC oldpvpvarx
   
   'STATIC maxpar
   
   maxpar = pvpvary MOD tilesize'Watch this cool optimization.
   
   IF oldpvpvary <> pvpvary THEN
      
      
      
      
      IF maxpar = -19 THEN pvpvary = pvpvary - 1
      omaGetScreenDimensions w, h 
      flippedpvpvary = -pvpvary
      RenderFirstY = flippedpvpvary \ tilesize
      RenderSecondY = (flippedpvpvary + h) \ tilesize
   END IF
   IF oldpvpvarx <> pvpvarx THEN
      omaGetScreenDimensions w, h 
      flippedpvpvarx = -pvpvarx
      RenderFirstX = flippedpvpvarx \ tilesize
      RenderSecondX = (RenderFirstX + 1) + (w \ tilesize)
      
   END IF
   
   
   
   
   oldpvpvarx = pvpvarx
   oldpvpvary = pvpvary
END SUB

SUB CameraFocus (x)
   
   omaGetScreenDimensions w, h 
   
   IF x <> Focus THEN Focus = x
   'yW - 118 = yP
   'xW - 82 = xP
	teomp = MultByTileSize(objects(x, 2)) + objects(x, 5) - (h / 2)
	IF -teomp > minimumpy THEN teomp = -minimumpy
	IF -teomp < maxpy THEN teomp = -maxpy
   
	pvpvary = -(teomp )
   
	teomp = MultByTileSize(objects(x, 1) ) + objects(x, 4) - (w / 2)
	IF -teomp > minimumpx THEN teomp = -minimumpx
	IF -teomp < maxpx THEN teomp = -maxpx
   
	pvpvarx = -(teomp )
   
   CameraFocusSprite = x
END SUB

SUB chooseItem (x AS INTEGER)
   'FUNCTION chooseSpell (x AS INTEGER)
   
   DIM button(4) AS INTEGER
   LeftKey$ = chr$(LArrow)
   RightKey$ = chr$(rArrow)
   UpKey$ = chr$(UpArrow)
   Downkey$ = chr$(DownArrow)
   BackKey$ = CHR$(27)
   notchosen = -1
   x = 0
   
   WHILE notchosen
      'MTKInkey key$
      key$ = ggetkey$
      SELECT CASE key$
      CASE BackKey$
         x = 1: EXIT SUB
      CASE UpKey$
         IF choice > 0 THEN choice = choice - 1
         
      CASE Downkey$
         IF choice < 30 THEN choice = choice + 1
         
         
      CASE " "
         
         IF LCASE$(itemlist(choice).Objectname) <> UCASE$(itemlist(choice).Objectname) THEN itemscript choice
         EXIT SUB
      END SELECT
      fullredraw
      battlebox
      
      FOR a = choice TO choice + 5
         
         IF a <= 30 THEN
            sprint 13 + a, itemlist(a).Objectname, 2 * -(choice = a)
            
         END IF
         
      NEXT a
      pageflip
   WEND
   
END SUB

FUNCTION chooseSpell (x AS INTEGER)
   
   
   dim notchosen
   dim t
   dim tScroll
   dim key$
   
   notchosen = -1
   t = 1
   tScroll = 0
   'gives you time to release the button!
   'digitalJstk up, down, left, right, button()
   
   WHILE (notchosen)
      'Read the input and empty the buffer.
      key$ = ggetkey
      
      
      '**First, we see where the user *wants* to go.
      SELECT CASE key$
      CASE " " ' space.
         IF battlescript(x, t) = 1 THEN notchosen = 0
      CASE chr$(DnArrow)
         t = t + 1
      CASE chr$(upArrow)
         t = t - 1
      CASE CHR$(8)'Backspace(why not?).
         
         'mirror the next one.
         chooseSpell = 0
         EXIT FUNCTION
      CASE chr$(27)
         
         chooseSpell = 0
         EXIT FUNCTION
         
         'return 0, exit sub, tell other sub not to do anything.
         'And don't remove the players built up time.
         
      END SELECT
		IF t = 0 THEN t = 1
		IF t > maxspells(x) THEN t = maxspells(x)
      
		IF t - 1 < tScroll THEN tScroll = t - 1
		IF t > (tScroll + 4) THEN tScroll = t + 1
      
      'Pointer:Everywhere you want to be :)
      objects(137, 1) = 0
      objects(137, 2) = 0
      objects(137, 3) = 47
      objects(137, 5) = pvpvary + 10
      objects(137, 4) = 160 + ((tScroll - t) * 12) - pvpvarx
      fullredraw
      battlebox
      showSpells 0, x, tScroll, t
      pageflip
      
      
      
   WEND
   'THIS IS WHERE I CAN CAST THE SPELL IN QUESTION.
   
   
	'Reseting the pointer object (we'll need it!)
	'and getting out of this sub.
   
   objects(137, 1) = 0
   objects(137, 2) = 0
   objects(137, 3) = 0
   objects(137, 4) = 0
   objects(137, 5) = 0
   chooseSpell = 1
   'WEND
   'THIS IS WHERE I CAN CAST THE SPELL IN QUESTION.
   
   
	'Reseting the pointer object (we'll need it)
	'and getting out of this sub.
   
   objects(137, 1) = 0
   objects(137, 2) = 0
   objects(137, 3) = 0
   objects(137, 4) = 0
   objects(137, 5) = 0
   chooseSpell = 1
   
END FUNCTION

SUB CombatMessage (text$)
   
   FOR a = 2 TO 10
      LinesOfText(a - 1) = LinesOfText(a)
   NEXT a
   LinesOfText(10) = text$
END SUB

SUB ConsoleMSG (message$)
   FOR a = 6 TO 9
      cbuffer$(a - 1) = cbuffer$(a)
   NEXT a
   cbuffer$(9) = message$
END SUB

SUB ctrlslp ()
	DIM button(4) AS INTEGER
   
   
	'This waits until you release the button before asking if you've
	'pressed the button. :)
   '   digitalJstk up, down, left, right, button()
   
	waiting = 1
   
   
   
	'This will wait under all circumstances.
   
	'it's crazy, but it just might work
   
   
   
END SUB

SUB DataGet ()
   'The players won't need this in the end. They will be around all the time.
   '...and don't remind me of how much easier an array would have been<->_<->
   PlayersCalculate players() 'This won't be needed later...
   
   
   enemies(1).iexp = (enemies(1).attack + enemies(1).defence) \ 2
   enemies(2).iexp = (enemies(2).attack + enemies(2).defence) \ 2
   enemies(3).iexp = (enemies(3).attack + enemies(3).defence) \ 2
   
   
END SUB

SUB deinit ()
   
   omaQuit () 
   
END SUB

SUB dialogbox (ison)
   calcrenderarea
   drawall
   'IF ObjectShadows = 1 THEN RenderObjectShadows
   renderobjects
   particleWeather
   
   
   battlebox
END SUB

SUB digitalJstk (up, dn, lf, rt, bt())
   
END SUB

SUB DirectStick (x, y, But1, But2, But3, but4)
END SUB

SUB drawall ()
   
   maxpar = pvpvary MOD tilesize
   FOR x = RenderFirstX TO RenderSecondX
      multedx = (x * tilesize) + PvPVarX
      FOR y = RenderFirstY TO RenderSecondY
         multedy = y * tilesize + pvpVarY
         omaqfakBlitImage multedx  ,multedy, map(x,y)+ 36, backBitmap  
      NEXT y
   NEXT x
   
END SUB

SUB Drawbattlemenu ()
   
   statsint
   keycontrol 0
   
   renderbattlemenu
   
END SUB

SUB drawgraph (x1, y1, leng, maxval, curval, color1, color2)
   DIM LengthOfColor1 AS INTEGER
   
   LengthOfColor1 = (leng / maxval) * curval
   
   FOR a = x1 TO x1 + leng - 1
      IF (a - x1) < LengthOfColor1 THEN col = color2 ELSE col = color1
      PSET8bit a, y1, col
      PSET8bit a, y1 + 1, col
      PSET8bit a, y1 + 2, col
      PSET8bit a, y1 + 3, col
      PSET8bit a, y1 + 4, col
      
   NEXT a
   
END SUB

SUB EnemyAttack (a)
   
   'First, Figure out who to attack.
   'Next, figure out how to attack them.
   'Finally, execute the attack.
   
   dim PlayerToAttack
   dim AttackMethod
   'Who to attack
   do
      PlayerToAttack = int(rnd(1) * 3) + 1
      
   loop while Players(PlayerToAttack).exists = 0

   
   'FIXME: INCLUDE OTHER ENEMY ATTACKS!!!
   If enemy.attacks = 1 then AttackMethod = 1
   
   firstX = (objects(enemies(a).sprite,1) * 20) + objects(enemies(a).sprite,4)
   SecondX = (objects(players(PlayerToAttack).sprite,1) * 20) + objects(players(PlayerToAttack).sprite,4) 
   
   firstY = (objects(enemies(a).sprite,2) * 20) + objects(enemies(a).sprite,5)
   SecondY = (objects(players(PlayerToAttack).sprite,2) * 20) + objects(players(PlayerToAttack).sprite,5) - (Tilesize / 2)
   
   RealX = FirstX - SecondX
   RealY = FirstY - SecondY
   
   Distance = (RealX^2 + RealY^2)^.5
   dim NewX as single
   DIM NewY as Single
   dim VeryNewX as single
   dim VeryNewY as single
   NewX = RealX / (distance / 6) + 0!
   NewY = RealY / (distance / 6)+ 0!

   'Move the enemy towards you.
   VeryNewX = FirstX
   VeryNewY = FirstY
   for x = 1 to (distance / 6)
      VeryNewX -= NewX
      VeryNewY -= NewY
      objects(enemies(a).sprite,1) = FIX(VeryNewX) \ 20
      objects(enemies(a).sprite,2) = FIX(VeryNewY) \ 20
      objects(enemies(a).sprite,4) = FIX(VeryNewX) MOD 20
      objects(Enemies(a).sprite,5) = FIX(VeryNewY) MOD 20
      FullRedraw
      BattleBox
      Drawbattlemenu
      omaPageFlip
   next x
   
   'DO THE ATTACK
   AttackPower =  enemies(a).attack + (enemies(a).attack * (RND(1) * 2!))
   OpposingPower = Players(PlayerToAttack).defence
   if OpposingPower >= AttackPower then 
      PainString$ = "Missed!"
   else
      PainString$ = str$(AttackPower - OpposingPower)
      Players(PlayerToAttack).hp -= (AttackPower - OpposingPower)
   end if
   
   
   PrintOnObject players(PlayerToAttack).sprite, PainString$,31
   for WasteFrames= 0 to 40
      FullRedraw
      BattleBox
      Drawbattlemenu
      PrintOnObject players(PlayerToAttack).sprite, PainString$,31
      omaPageFlip
   next WasteFrames
   
   
   'Move the enemy back.
   for x = 1 to (distance / 6)
      VeryNewX += NewX
      VeryNewY += NewY
      objects(enemies(a).sprite,1) = VeryNewX \ 20
      objects(enemies(a).sprite,2) = VeryNewY \ 20
      objects(enemies(a).sprite,4) = VeryNewX MOD 20
      objects(Enemies(a).sprite,5) = VeryNewY MOD 20
      FullRedraw
      PrintOnObject players(PlayerToAttack).sprite, PainString$,31
      BattleBox
      Drawbattlemenu
      omaPageFlip
   next x
   
   
END SUB

SUB fileread (location, File)
   DIM filenum AS INTEGER
   
   filenum = FREEFILE
   
   LastFileLoaded = File
   DIM readme#(0 TO 15, 0 TO 15)
   FOR a = 0 TO 170
      FOR b = 0 TO 170
         map(a, b) = 0
      NEXT b
   NEXT a
   addToDebug "map array cleared"
   filen = FREEFILE
   
   OPEN "maps.txt" FOR INPUT AS #filen
   
   
	WHILE thestring$ <> "case " + STR$(File)
      INPUT #filen, thestring$
   WEND
   
   INPUT #filen, thestring$
   maxmapy = VAL(MID$(thestring$, 8))
   
   INPUT #filen, thestring$
   maxmapx = VAL(MID$(thestring$, 8))
   
   INPUT #filen, thestring$
   filestring$ = RTRIM$(LTRIM$(thestring$ + ".txt"))
   
   CLOSE filen
   addToDebug "file selected"
   ' Objects(-100 TO 140, 1 TO 6)  AS INTEGER
   objectstring$ = RTRIM$(LTRIM$(thestring$ + ".obf"))
   
   
   
   OPEN objectstring$ FOR INPUT AS #filen
   
   addToDebug "Object file "+ objectstring$+ " read."
   
   FOR y = -100 TO 140                          ' This little routine reads the DATA
      FOR x = 1 TO 10 'Just don't load 10, and it remains constant and scripted.
         IF x <> 10 THEN
            INPUT #filenum, objects(y, x)
         ELSE
            INPUT #filenum, clonehigh
         END IF
         
      NEXT x
   NEXT y
   
   CLOSE #filenum
   addToDebug "objects loaded"
   
   
   OPEN filestring$ FOR INPUT AS #filen
   
   FOR y = 1 TO maxmapy
      FOR x = 0 TO maxmapx
         INPUT #filenum, map(x, y)
         'map(x,y) += 36
         'FIXME: WE NEED REASONABLE MAP FORMATS!!!!!
      NEXT x
   NEXT y
   
   CLOSE #filenum
   
   90210
   objects(1, 3) = people(objects(1, 10)).up(1)
   
END SUB

FUNCTION FreeSprite ()
   FOR a = -99 TO 135'135 TO -99 STEP -1
      FOR b = 1 TO 5
         IF objects(a, b) <> 0 THEN
            b = 1
            a = a + 1
         ELSE
            FreeSprite = a
            EXIT FUNCTION
         END IF
         FreeSprite = 0
      NEXT b
   NEXT a
END FUNCTION

SUB fullredraw ()
	'Rendering
	drawall                'Draws everything on the screenSurfaces background.
   '    IF ObjectShadows = 1 THEN RenderObjectShadows
	renderobjects          'Draws the objects (people & stuff)
   particleWeather
   
	UpdateDebug ' I'm just so glad it's back
	GOSUB rawtext
   
   EXIT SUB
   rawtext:
   FOR a = 0 TO 10
      sprint a + 3, LinesOfText(a), 1
   NEXT a
   
   
END SUB

SUB fullscrpic (Filename$, page)
   addtodebug filename$
   dim SDL_Picture as SDL_Surface ptr
   SDL_Picture = omaLoadMaskedGraphic (Filename$) 
   omaBlitImage 0,0,SDL_Picture
   
   omaKillSurface SDL_Picture
   pageflip
   
END SUB

SUB Getgrad (TargetR, TargetG, TargetB)
   
END SUB

SUB getLastUsed (x)
   x = lastused
END SUB

SUB getpal ()
   'SHARED fileno
   
   fileno = FREEFILE
   
   OPEN "jrpg.pal" FOR INPUT AS #fileno
   FOR a = 0 TO 255
      FOR b = 1 TO 3
         
         INPUT #fileno, pall(a, b)
         
      NEXT b
   NEXT a
   
   close #fileno
   
   
END SUB

SUB getpalette (l, r, g, b)
   'I just pointed this to the array. It's more efficient than checking for real
   'each time.
   r = pall(l, 1)
   g = pall(l, 2)
   b = pall(l, 3)
   
   
   
   
   
   
END SUB

FUNCTION GetParameter$ (commst$, x)
   Realcommst$ = LTRIM$(RTRIM$(commst$))
   IF x < 1 THEN x = 1
   FOR b = 1 TO x
      vin = INSTR(1, LTRIM$(RTRIM$(Realcommst$)), " ")
      IF vin = 0 THEN vin = 1: GetReadyToEnd = -1
      IF b < x THEN Realcommst$ = MID$(LTRIM$(RTRIM$(Realcommst$)), vin)
      IF GetReadyToEnd THEN
         GetParameter$ = LTRIM$(RTRIM$(Realcommst$))
         EXIT FUNCTION
      END IF
   NEXT b
   GetParameter$ = LTRIM$(RTRIM$(LEFT$(Realcommst$, vin)))
END FUNCTION

FUNCTION GetParameter2$ (commst$, x)
   Realcommst$ = LTRIM$(RTRIM$(commst$))
   IF x < 1 THEN x = 1
   FOR b = 1 TO x
      vin = INSTR(1, LTRIM$(RTRIM$(Realcommst$)), " ")
      IF vin = 0 THEN vin = 1: GetReadyToEnd = -1
      IF b < x THEN Realcommst$ = MID$(LTRIM$(RTRIM$(Realcommst$)), vin)
      IF GetReadyToEnd THEN
         GetParameter2$ = LTRIM$(RTRIM$(Realcommst$))
         EXIT FUNCTION
      END IF
   NEXT b
   GetParameter2$ = LTRIM$(RTRIM$(LEFT$(Realcommst$, vin)))
END FUNCTION

SUB GetPixel (x, y, Culler, pag)
   
   oldx = x
END SUB

function GetSingleKey as integer
   static LastKey
   static LastTime
   
   
   dim code as integer
   
   
   for a = 512 to 0 step -1
      if a = 329 then a = 325
      if omaMultiKey (a) then code = a 
   next a
   if code = 0 then LastKey = 0:exit function
   
   
   if (LastKey <> code or LastTime < SDL_GetTicks())  then
      LastKey = code
      GetSingleKey = code
      LastTime = SDL_GetTicks() + 500
   end if
   
END function

SUB gLOAD (x)
   
   fileno = FREEFILE
   OPEN ".\save\save" + LTRIM$(RTRIM$(STR$(x))) + ".sav" FOR BINARY AS #fileno
   
   
   
   FOR a = 1 TO 3
      GET #fileno, , players(a).sname
      GET #fileno, , players(a).hp
      GET #fileno, , players(a).maxhp
      GET #fileno, , players(a).mp
      GET #fileno, , players(a).maxmp
      GET #fileno, , players(a).Experience
      GET #fileno, , players(a).level
   NEXT a
   
   FOR a = 0 TO 170
      FOR b = 0 TO 170
         GET #fileno, , map(a, b)
      NEXT b
   NEXT a
   
   
   FOR a = 0 TO 512
      GET #fileno, , ScriptArraySpace(a)
   NEXT a
   
   FOR a = -100 TO 140
      FOR b = 1 TO 10
         GET #fileno, , objects(a, b)
      NEXT b
   NEXT a
   
   GET #fileno, , oldsy
   GET #fileno, , CameraFocusSprite
   GET #fileno, , bigmapx
   GET #fileno, , bigmapy
   GET #fileno, , walkspeed
   GET #fileno, , debug
   GET #fileno, , whatthefuck
   GET #fileno, , pvpvarx
   GET #fileno, , pvpvary
   GET #fileno, , px
   GET #fileno, , py
   GET #fileno, , ar
   GET #fileno, , ay
   GET #fileno, , minimumpx
   GET #fileno, , minimumpy
   GET #fileno, , maxpx
   GET #fileno, , maxpy
   GET #fileno, , RAtimer
   GET #fileno, , LAtimer
   GET #fileno, , UAtimer
   GET #fileno, , DAtimer
   GET #fileno, , ScriptCalledFromSprite
   GET #fileno, , VSyncActive
   GET #fileno, , Focus
   GET #fileno, , BackGroundFileName
   GET #fileno, , ForeGroundFileName
   GET #fileno, , UseJoystick
   GET #fileno, , ObjectShadows
   GET #fileno, , weather
   
   FOR a = 0 TO 30
      GET #fileno, , itemlist(a).Objectname
      GET #fileno, , itemlist(a).attributes
      GET #fileno, , itemlist(a).Quantity
   NEXT a
   FOR a = 1 TO 3
      GET #fileno, , players(a).hp
      GET #fileno, , players(a).mp
      GET #fileno, , players(a).maxhp
      GET #fileno, , players(a).maxmp
      GET #fileno, , players(a).time
      GET #fileno, , players(a).speed
      GET #fileno, , players(a).speedmod
      GET #fileno, , players(a).attack
      GET #fileno, , players(a).defence
      GET #fileno, , players(a).dead
      GET #fileno, , players(a).exists
      GET #fileno, , players(a).sname
      GET #fileno, , players(a).ready
      GET #fileno, , players(a).Experience
      GET #fileno, , players(a).level
      GET #fileno, , players(a).gold
      GET #fileno, , players(a).maxspells
      GET #fileno, , players(a).sprite
   NEXT a
   FOR a = 1 TO 10
      FOR b = 1 TO 3
         GET #fileno, , people(a).up(b)
         GET #fileno, , people(a).down(b)
         GET #fileno, , people(a).left(b)
         GET #fileno, , people(a).right(b)
         GET #fileno, , people(a).special(b)
      NEXT b
      GET #fileno, , people(a).upbattle(1)
      GET #fileno, , people(a).downbattle(1)
      GET #fileno, , people(a).leftbattle(1)
      GET #fileno, , people(a).rightbattle(1)
      GET #fileno, , people(a).upslash(1)
      GET #fileno, , people(a).downslash(1)
      GET #fileno, , people(a).leftslash(1)
      GET #fileno, , people(a).rightslash(1)
      
      GET #fileno, , people(a).battleslash(1)
   NEXT a
   
   
   GET #fileno, , CurrentMusic$
   
   CLOSE fileno
   
END SUB

SUB gLoadNames ()
END SUB

FUNCTION GreyScale (colr)
   'New function: Converts to greyscale gradient.
   'GreyScale = Gradient((pall(colr, 1) + pall(colr, 2) + pall(colr, 3)) \ 12)
   
   
END FUNCTION

SUB HealingTargetSelect (objects(), players() AS Player, decision)
   DIM button(4) AS INTEGER
   LeftKey$ = chr$(lArrow)
   RightKey$ = chr$(rArrow)
   UpKey$ = chr$(UpArrow)
   Downkey$ = chr$(DnArrow)
   BackKey$ = CHR$(27)
   notchosen = -1
   t = 1
   
   'gives you time to release the button
   'digitalJstk up, down, left, right, button()
   
   
   
   WHILE (notchosen)
      'Read the input and empty the buffer.
      'MTKInkey key$
      key$ = ggetkey$
      'more of that lovely hacking
      '   digitalJstk up, down, left, right, button()
      '   IF up THEN key$ = UpKey$
      '   IF down THEN key$ = Downkey$
      '   IF left THEN key$ = LeftKey$
      '   IF right THEN key$ = RightKey$
      
      '   IF button(1) THEN key$ = " "
      '   IF button(4) THEN key$ = BackKey$
      
      
      '**First, we see where the user *wants* to go.
      SELECT CASE key$
      CASE " " ' space.
         notchosen = 0
      CASE Downkey$
         t = t - 1
         dn = 1
      CASE UpKey$
         t = t + 1
      CASE RightKey$
         t = t - 1
         dn = 1
      CASE LeftKey$
         t = t + 1
      CASE CHR$(8)'Backspace(why not?).
         
         'mirror the next one.
         objects(137, 1) = 0
         objects(137, 2) = 0
         objects(137, 3) = 0
         objects(137, 4) = 0
         objects(137, 5) = 0
         
         
         decision = 0
         EXIT SUB
      CASE BackKey$
         
         objects(137, 1) = 0
         objects(137, 2) = 0
         objects(137, 3) = 0
         objects(137, 4) = 0
         objects(137, 5) = 0
         
         decision = 0
         EXIT SUB
         
         'return 0, exit sub, tell other sub not to do anything.
         'And don't remove the players built up time.
         
      END SELECT
		IF t = 0 THEN t = 3
		IF t = 4 THEN t = 1
      
      'If the enemy doesn't exist there, keep shifting to find one.
      IF dn = 0 THEN
         WHILE players(t).dead = 1
            t = t + 1
            IF t = 4 THEN t = 1
         WEND
      ELSE
         
         WHILE players(t).dead = 1
            t = t - 1
            IF t = 0 THEN t = 3
         WEND
      END IF
      
      'Pointer:Everywhere you want to be :)
      objects(137, 1) = objects(players(t).sprite, 1)
      objects(137, 2) = objects(players(t).sprite, 2)
      objects(137, 3) = 47
      objects(137, 4) = objects(players(t).sprite, 4)
      objects(137, 5) = objects(players(t).sprite, 5)
      
      fullredraw
      battlebox
      pageflip
      
      
      
   WEND
	'Reseting the pointer object (we'll need it)
	'and getting out of this sub.
   objects(137, 1) = 0
   objects(137, 2) = 0
   objects(137, 3) = 0
   objects(137, 4) = 0
   objects(137, 5) = 0
   decision = t
   
   
END SUB

FUNCTION Healthadd (a, add)
   
	'what was I smoking when I wrote that?
	'IF players(a).maxhp < players(a).hp + add THEN
	'    add = players(a).maxhp - players(a).hp
   
	'END IF
   
   
	IF players(a).maxhp <= (players(a).hp + add) THEN
      '    add = players(a).maxhp - players(a).hp
      players(a).hp = players(a).maxhp
      'I'm NOT fucking up my variables for a cheap thrill like that
      add2 = players(a).maxhp - players(a).hp
      
      
   ELSE
      players(a).hp = players(a).hp + add
      add2 = add
   END IF
   
   
   
	Healthadd = add2
   
END FUNCTION

FUNCTION isolate$ (y$, x)
   isolate$ = MID$(y$, x, 1)
END FUNCTION

SUB itemadd (Itemname$, attributes2)
   FOR a = 0 TO 30
      newtered$ = LCASE$(LTRIM$(RTRIM$(itemlist(a).Objectname)))
      IF newtered$ = LCASE$(LTRIM$(RTRIM$(Itemname$))) THEN
         itemlist(a).Quantity = 1 + itemlist(a).Quantity
         EXIT SUB
      END IF
   NEXT a
   
   FOR a = 0 TO 30
      IF LCASE$(itemlist(a).Objectname) = UCASE$(itemlist(a).Objectname) THEN
         itemlist(a).Quantity = 1
         itemlist(a).attributes = attributes2
         itemlist(a).Objectname = LCASE$(RTRIM$(LTRIM$(Itemname$)))
         EXIT SUB
      END IF
   NEXT a
   
END SUB

SUB itemRemove (itemno)
   a = itemno
   itemlist(a).Quantity = itemlist(a).Quantity - 1
   IF itemlist(a).Quantity = 0 THEN
		itemlist(a).attributes = 0
		itemlist(a).Objectname = ""
   END IF
   
END SUB

SUB itemscript (itemno)
   IF itemlist(itemno).attributes < 100 THEN healdivider = healdivider + 1
   
   
   'COMMON SHARED itemlist() AS userobject
   'userobject
   SELECT CASE itemlist(itemno).attributes
   CASE 1 '100hp potion
      itemRemove (itemno)
      
      HealingTargetSelect objects(), players(), x
      playerdefendadd = Healthadd(x, 100 / healdivider)'15 rather than playerhealth / 15
      fullredraw
      PrintOnObject players(x).sprite, STR$(playerdefendadd), 2
      
   CASE 2 '1000hp potion
      itemRemove (itemno)
      
      
      HealingTargetSelect objects(), players(), x
      
      playerdefendadd = Healthadd(x, 1000 / healdivider)'15 rather than playerhealth / 15
      fullredraw
      PrintOnObject players(x).sprite, STR$(playerdefendadd), 2
      
      
   CASE 3 '10,000HP potion
      itemRemove (itemno)
      
      
      HealingTargetSelect objects(), players(), x
      
      playerdefendadd = Healthadd(x, 10000 / healdivider)'15 rather than playerhealth / 15
      fullredraw
      PrintOnObject players(x).sprite, STR$(playerdefendadd), 2
      
      
   CASE 11 '10MP potion (price=2xMP)
      itemRemove (itemno)
      
      
      HealingTargetSelect objects(), players(), x
      
      playerdefendadd = Magicadd(x, 10 / healdivider)
      
      fullredraw
      PrintOnObject players(x).sprite, STR$(playerdefendadd), 2
   CASE 12 '100MP potion
      itemRemove (itemno)
      
      
      HealingTargetSelect objects(), players(), x
      playerdefendadd = Magicadd(x, 100 / healdivider)
      
      fullredraw
      PrintOnObject players(x).sprite, STR$(playerdefendadd), 2
      
   CASE 13 '1000MP potion
      itemRemove (itemno)
      
      
      HealingTargetSelect objects(), players(), x
      
      playerdefendadd = Magicadd(x, 1000 / healdivider)
      
      fullredraw
      PrintOnObject players(x).sprite, STR$(playerdefendadd), 2
      
      
   CASE 14 '10,000MP potion(zoinks that would cost a mint)
      itemRemove (itemno)
      
      
      HealingTargetSelect objects(), players(), x
      playerdefendadd = Magicadd(x, 10000 / healdivider)
      
      fullredraw
      PrintOnObject players(x).sprite, STR$(playerdefendadd), 2
      
      
   CASE 31 'BattleRevive Mk. 1(10 HP revived)
      itemRemove (itemno)
      
      
      HealingTargetSelect objects(), players(), x
      playerdefendadd = Magicadd(x, players(x).maxhp * .1)
      players(x).dead = 0
      
      
      AniSequence objects(players(x).sprite, 1), objects(players(x).sprite, 2) - 1, objects(players(x).sprite, 4), objects(players(x).sprite, 5), 128, 136
      
      FOR h = 1 TO 5
         fullredraw
         PrintOnObject players(x).sprite, STR$(playerdefendadd), 2
         pageflip
         
      NEXT h
      
      pwait 1
      
   CASE 100 'fence relic
      itemRemove (itemno)
      
      
   CASE 101 'tar pit relic
      itemRemove (itemno)
      
      
      
      
   END SELECT
   
   
END SUB

SUB keycontrol (keymode)
   keycode = 0
   keycode = GetSingleKey
   
   'this is just a hack to make it work, but it's a hack which will do the trick.
   
   
   
   
   
   IF keycode = oldkeycode THEN
      
      
      resetcode = 1
   END IF
   oldkeycode = keycode
   
   IF resetcode = 1 THEN keycode = 0: resetcode = 0
   
   
   
   SELECT CASE keycode
   CASE rarrow
		'I have to use ugly code here. I'm really ashamed. really.
		IF battleX = 1 THEN
			IF players(2).ready = True THEN
				battleX = 2
         ELSEIF players(3).ready = True THEN
				battleX = 3
         ELSE
				battleX = 1
         END IF
      ELSEIF battleX = 2 THEN
			IF players(3).ready = True THEN battleX = 3
      END IF
      
   CASE larrow
		IF battleX = 3 THEN
			IF players(2).ready = True THEN
				battleX = 2
         ELSEIF players(1).ready = True THEN
				battleX = 1
         ELSE
				battleX = 3
         END IF
      ELSEIF battleX = 2 THEN
			IF players(1).ready = True THEN battleX = 1
      END IF
      
   CASE Uparrow 'The up and down arrows are horrible too...
		battley = battley - 1
		IF battley = 0 THEN battley = 1
   CASE Dnarrow
      battley = battley + 1
      IF battley = 5 THEN battley = 4
   CASE Spacebar
      IF keymode = 1 THEN
         IF players(battleX).ready = True THEN
            SELECT CASE battley
            CASE 1
               PlayerAttack (battleX)
               IF players(battleX).time = 0 THEN
                  players(battleX).ready = False
               END IF
               
               WaitForReadyPlayer = True
               FOR a = 1 TO 3
                  IF players(a).ready = True THEN
                     battleX = a
                     WaitForReadyPlayer = False
                     a = 4
                  END IF
               NEXT a
            CASE 2
				   players(battleX).ready = False
				   players(battleX).time = 0
				   playerdefendadd = Healthadd(battleX, players(battleX).maxhp * .15)'15 rather than playerhealth / 15
				   'players(battlex).hp = players(battlex).hp + playerdefendadd
               
               fullredraw
               PrintOnObject players(x).sprite, STR$(playerdefendadd), 2
               
               battlebox
               pageflip
               pwait (.5)
               
               WaitForReadyPlayer = True
               FOR a = 1 TO 3
                  IF players(a).ready = True THEN
                     battleX = a
                     WaitForReadyPlayer = False
                     a = 4
                  END IF
               NEXT a
               
            CASE 3
				   'WHOO HOO MAGIC MENU LALALALALA
				   IF chooseSpell(battleX) = 1 THEN
                  players(battleX).ready = False
                  players(battleX).time = 0
                  
                  WaitForReadyPlayer = True
                  FOR a = 1 TO 3
                     IF players(a).ready = True THEN
                        battleX = a
                        WaitForReadyPlayer = False
                        a = 4
                     END IF
                  NEXT a
               END IF
            CASE 4
				   'WHOO HOO ITEM MENU Oddly enough, installed on a tuesday
					res = 0
					chooseItem (res)
               IF res = 0 THEN
					   players(battleX).ready = False
					   players(battleX).time = 0
                  
                  WaitForReadyPlayer = True
                  FOR a = 1 TO 3
                     IF players(a).ready = True THEN
                        battleX = a
                        WaitForReadyPlayer = False
                        a = 4
                     END IF
                  NEXT a
               END IF
            END SELECT
            
         END IF
      END IF
   CASE Esc 'You want to quit the game during battle? LOSE.
      
   CASE Tilde
		console page, objects(), people()
      
   END SELECT
   
END SUB

FUNCTION keyflag (x)
   keyflag = omaMultiKey (x) 
END FUNCTION

SUB Linegoto (byval Spritenumber as integer,byval Sprite2number as integer,byval Shift) 
   'one heads to the other.
   
   IF Spritenumber >= 1 AND Spritenumber <= 3 THEN KKJ = Spritenumber
   IF Sprite2number >= 1 AND Sprite2number <= 3 THEN KKJ = Sprite2number
   
   DIM slopex AS SINGLE
   DIM slopey AS SINGLE
   
   DIM steps AS INTEGER
   DIM Xone AS INTEGER
   DIM Yone AS INTEGER
   DIM Xtwo AS INTEGER
   DIM Ytwo AS INTEGER
   
   Xone = (objects(Spritenumber, 1) * tilesize) + objects(Spritenumber, 4)
   Yone = (objects(Spritenumber, 2) * tilesize) + objects(Spritenumber, 5)
   
   Xtwo = (objects(Sprite2number, 1) * tilesize) + objects(Sprite2number, 4)
   Ytwo = (objects(Sprite2number, 2) * tilesize) + objects(Sprite2number, 5) + Shift
   
   steps = (ABS(Xone - Xtwo) + ABS(Yone - Ytwo)) \ 10
   
   
   'Startx = Xone
   'starty = Yone
   slopex = (Xtwo - Xone) / steps
   slopey = (Ytwo - Yone) / steps
   
   
   FOR a = 1 TO steps
      nocdmoveobject Spritenumber, slopex, slopey
      
		fullredraw
		battlebox
      statsint
      keycontrol 0
      
      renderbattlemenu
      
		pageflip
      
   NEXT a
   ' ConsoleMsg "LineGoto End" + STR$(SpriteNumber)
   
   
   
   
END SUB

SUB linemove (Spritenumber, Sprite2number, Shift)
   '                      SHARED x, y
   
   
   'linemove (Spritenumber, Sprite2number, Shift)
   sssss = Spritenumber
   IF Spritenumber >= 1 AND Spritenumber <= 3 THEN KKJ = Spritenumber
   IF Sprite2number >= 1 AND Sprite2number <= 3 THEN KKJ = Sprite2number
   
   DIM slopex AS SINGLE
   DIM slopey AS SINGLE
   
   DIM steps AS INTEGER
   DIM Xone AS INTEGER
   DIM Yone AS INTEGER
   DIM Xtwo AS INTEGER
   DIM Ytwo AS INTEGER
   
   Xone = (objects(Spritenumber, 1) * tilesize) + objects(Spritenumber, 4)
   Yone = (objects(Spritenumber, 2) * tilesize) + objects(Spritenumber, 5)
   
   Xtwo = (objects(Sprite2number, 1) * tilesize) + objects(Sprite2number, 4)
   Ytwo = (objects(Sprite2number, 2) * tilesize) + objects(Sprite2number, 5) + Shift
   
   steps = (ABS(Xone - Xtwo) + ABS(Yone - Ytwo)) \ 10
   
   
   'Startx = Xone
   'starty = Yone
   slopex = (Xtwo - Xone) / steps
   slopey = (Ytwo - Yone) / steps
   
   
   'Startx = Xone
   'starty = Yone
   
	FOR a = 1 TO steps
      
      nocdmoveobject sssss, slopex, slopey
      IF players(KKJ).dead = False THEN
         objects(140 - KKJ, 1) = objects(KKJ, 1)
         objects(140 - KKJ, 2) = objects(KKJ, 2)
         objects(140 - KKJ, 3) = 44
         objects(140 - KKJ, 4) = objects(KKJ, 4)
         objects(140 - KKJ, 5) = objects(KKJ, 5)
         
      END IF
      
      
		fullredraw
		battlebox
		Drawbattlemenu
      
		pageflip
      
      '   Startx = Startx + slopex
      '   starty = starty + slopey
   NEXT a
	'140
   
   objects(140, 1) = objects(Sprite2number, 1)
   objects(140, 2) = objects(Sprite2number, 2)
   objects(140, 3) = 21
   objects(140, 4) = objects(Sprite2number, 4)
   objects(140, 5) = objects(Sprite2number, 5)
   
   IF players(KKJ).dead = False THEN
		objects(140 - KKJ, 1) = objects(KKJ, 1)
		objects(140 - KKJ, 2) = objects(KKJ, 2)
		objects(140 - KKJ, 3) = 44
		objects(140 - KKJ, 4) = objects(KKJ, 4)
		objects(140 - KKJ, 5) = objects(KKJ, 5)
      
   END IF
   
	FOR a = 1 TO 15
      IF players(KKJ).dead = False THEN
         objects(140 - KKJ, 1) = 0
         objects(140 - KKJ, 2) = 0
         objects(140 - KKJ, 3) = 0
         objects(140 - KKJ, 4) = 0
         objects(140 - KKJ, 5) = 0
         
      END IF
      
		fullredraw
		battlebox
      
		Drawbattlemenu
		pageflip
   NEXT a
   
   objects(140, 1) = 0
   objects(140, 2) = 0
   objects(140, 3) = 0
   
	FOR a = 1 TO steps
		nocdmoveobject Spritenumber, -slopex, -slopey
      IF players(KKJ).dead = False THEN
         objects(140 - KKJ, 1) = objects(KKJ, 1)
         objects(140 - KKJ, 2) = objects(KKJ, 2)
         objects(140 - KKJ, 3) = 44
         objects(140 - KKJ, 4) = objects(KKJ, 4)
         objects(140 - KKJ, 5) = objects(KKJ, 5)
         
      END IF
      
		fullredraw
		battlebox
		Drawbattlemenu
      
		pageflip
      
   NEXT a
   
   
   
END SUB

SUB loadchars ()
   fileno = FREEFILE
   OPEN ".\data\chars.spr" FOR INPUT AS #fileno
   'charsprites(1 TO 6, 1 to 8, 32 TO 90)
   
   FOR c = 32 TO 90
      FOR a = 1 TO 6
         INPUT #fileno, charsprites(a, c)
      NEXT a
   NEXT c
   CLOSE fileno
END SUB

FUNCTION Magicadd (a, add)
   
	IF players(a).maxmp <= (players(a).mp + add) THEN
      players(a).mp = players(a).maxmp
      'I'm NOT fucking up my variables for a cheap thrill like that
      add2 = players(a).maxmp - players(a).mp
      
      
   ELSE
      players(a).mp = players(a).mp + add
      add2 = add
   END IF
   
   
   
	Magicadd = add2
END FUNCTION

FUNCTION MagicName$ (playa AS INTEGER, attack AS INTEGER)
   
   MagicName$ = ReadLine(playa, attack, 0) 'the first line of every attack is the
   'attack name.
   
END FUNCTION

FUNCTION maxspells (sname AS INTEGER)
	DIM lin AS STRING
	WHILE (lin <> "Out of Bounds")
		no = no + 1
		lin = MagicName(sname, no)
   WEND
	IF players(sname).level < no THEN no = players(sname).level
	maxspells = no - 1
   
   
END FUNCTION


SUB menuActive ()
   DIM button(4)               AS INTEGER
   DIM dplayermhp(1 TO 3)      AS LONG 'INTEGER
   DIM dplayermmp(1 TO 3)      AS LONG 'INTEGER
   DIM dplayerhp(1 TO 3)       AS LONG 'INTEGER
   DIM dplayermp(1 TO 3)       AS LONG 'INTEGER
   
   
   DIM dplayername(1 TO 3)     AS STRING * 7
   DIM dplayerexp(1 TO 3)      AS DOUBLE
   DIM dplayerlevel(1 TO 3)    AS INTEGER
   
   countdown = 30
	DIM lines(1 TO 5) AS STRING
   
   subchoice = 0
	currentchoice = 1
   
   DIM colours(1 TO 5)
   exitmenu = False
   WHILE (exitmenu = False)
      
      
      keycod = GetSingleKey
      
      
      'digitalJstk up, down, left, right, button()
      
      '   IF up THEN keycod = (Uparrow)
      '   IF down THEN keycod = (Dnarrow)
      '   IF left THEN keycod = (larrow)
      '   IF right THEN keycod = (rarrow)
      
      '   IF button(1) THEN keycod = (Spacebar)
      '   IF button(3) THEN keycod = Esc
      
      
      
      IF keycod = oldkeycode THEN
         
         
         
         resetcode = 1
      END IF
      oldkeycode = keycod
      
      IF resetcode = 1 THEN keycod = 0: resetcode = 0
      
      IF countdown > 0 THEN
         IF keycod = Esc THEN keycod = 0
         countdown = countdown - 1
         
      END IF
      
      'IF keycod = esc THEN countdown = countdown - 1
      'IF countdown <> 0 THEN keycod = 0
      
      
      pageflip
      MoveWater
      MoveTransition
      drawall
		'    IF ObjectShadows = 1 THEN RenderObjectShadows
      renderobjects
      particleWeather
      transbox 30, 290, 30, 210
      
      
      SELECT CASE keycod
      CASE Esc
         exitmenu = True
         '             WHILE (INP(96) <> Esc + 128): WEND
      CASE larrow
         currentchoice = currentchoice - 1
         subchoice = 0
         SaveChanged = 1
      CASE rarrow
         currentchoice = currentchoice + 1
         subchoice = 0
         SaveChanged = 1
         
      CASE Uparrow
         subchoice = subchoice - 1
         SaveChanged = 1
      CASE Dnarrow
         subchoice = subchoice + 1
         SaveChanged = 1
      CASE Spacebar
         SaveChanged = 1
         
         
			SELECT CASE currentchoice
         CASE 1 'Player statistics
         CASE 2 'Player Equipment and items
            healdivider = 0
            itemscript subchoice
            healdivider = 0
            
         CASE 3 'Player Magic
            'IF a = subchoice THEN aplaya = playa: disp = a - olda
			   falsehood = battlescript(subchoice, 1)
            ' xsprint 1, 1, STR$(aplaya) + "  " + STR$(disp), 2
            
            
         CASE 4 'Player savegames
            save (subchoice)
            'FIXME:Insert verification screenSurface
         CASE 5 'Player exit
            IF subchoice = 1 THEN deinit
            
         END SELECT
         
      END SELECT
      
      IF currentchoice < 1 THEN currentchoice = 5
      IF currentchoice > 5 THEN currentchoice = 1
      
      FOR a = 1 TO 5
         colours(a) = 24
      NEXT a
      colours(currentchoice) = 1
      
      xsprint 35, 34, "Stats", 0
      xsprint 35, 81, "Items", 0
      xsprint 35, 154, "Magic", 0
      xsprint 35, 204, "Save", 0
      xsprint 35, 249, "Exit", 0
      
      
      xsprint 35, 35, "Stats", colours(1)
      xsprint 35, 82, "Items", colours(2)
      xsprint 35, 155, "Magic", colours(3)
      xsprint 35, 205, "Save", colours(4)
      xsprint 35, 250, "Exit", colours(5)
      
      
      'here I write the info pertient to the specific items.
      SELECT CASE currentchoice
      CASE 1 'Player statistics
         
         FOR Z = 1 TO 3
            IF LTRIM$(RTRIM$(LCASE$(players(Z).sname))) <> "none" THEN
               xsprint 52 + ((Z - 1) * 48), 35, players(Z).sname, 2'31
               
               xsprint 67 + ((Z - 1) * 48), 35, "Level:" + STR$(players(Z).level), 31
               'xsprint 67 + ((z - 1) * 48), 35, "Level:" + STR$(players(z).level), 31
               xsprint 80 + ((Z - 1) * 48), 35, "Exp:" + STR$(players(Z).Experience), 31
               
               xsprint 52 + ((Z - 1) * 48), 180, "HP:" + STR$(players(Z).hp) + "/" + STR$(players(Z).maxhp), 31
               xsprint 67 + ((Z - 1) * 48), 180, "MP:" + STR$(players(Z).mp) + "/" + STR$(players(Z).maxmp), 31
               
            END IF
         NEXT Z
      CASE 2 'Player Equipment and items
         IF subchoice < 0 THEN subchoice = 0
         IF subchoice > 30 THEN subchoice = 30
         
         
         FOR a = subchoice TO subchoice + 5
            
            IF a <= 30 THEN
               xsprint 52 + (15 * (a - subchoice)), 35, itemlist(a).Objectname + "     " + STR$(itemlist(a).Quantity), 2 * -(subchoice = a) + 19 * -(subchoice <> a)
               
            END IF
            
         NEXT a
         
      CASE 3 'Player Magic
         IF subchoice <= 0 THEN subchoice = 1
         
         FOR a = 1 TO 3
            bu$ = players(a).sname
            bu$ = LCASE$(LTRIM$(RTRIM$(bu$)))
            IF bu$ <> "none" THEN
               xsprint 52 + ((a - 1) * 30), 35, players(a).sname, 2
               xsprint 67 + ((a - 1) * 30), 35, MagicName(a, 1), 31 * -(a = subchoice)
               maxplayers = a
            END IF
         NEXT a
         IF subchoice > maxplayers THEN subchoice = maxplayers - 1
         
         
      CASE 4 'Player savegames
         
         IF subchoice > 4 THEN subchoice = 0
         IF subchoice < 0 THEN subchoice = 0
         
         
         xsprint 52, 35, "Save 1", 31 * -(subchoice = 0) + (25 * -(subchoice <> 0))
         
         xsprint 67, 35, "Save 2", 31 * -(subchoice = 1) + (25 * -(subchoice <> 1))
         
         xsprint 80, 35, "Save 3", 31 * -(subchoice = 2) + (25 * -(subchoice <> 2))
         
         xsprint 95, 35, "Save 4", 31 * -(subchoice = 3) + (25 * -(subchoice <> 3))
         
         xsprint 110, 35, "Save 5", (31 * -(subchoice = 4)) + (25 * -(subchoice <> 4))
         
         'New addition: Now savegame statistics are shown.
         IF SaveChanged = 1 THEN
            SaveChanged = 0
            filenoX = FREEFILE
            OPEN ".\save\save" + LTRIM$(RTRIM$(STR$(subchoice))) + ".sav" FOR BINARY AS #filenoX
            
            FOR a = 1 TO 3
               GET #filenoX, , dplayername(a)
               GET #filenoX, , dplayerhp(a)
               GET #filenoX, , dplayermhp(a)
               GET #filenoX, , dplayermp(a)
               GET #filenoX, , dplayermmp(a)
               GET #filenoX, , dplayerexp(a)
               GET #filenoX, , dplayerlevel(a)
            NEXT a
            
            
            
            CLOSE #filenoX
            
         END IF
			b = 0
         FOR a = 1 TO 3
            
            IF (LTRIM$(RTRIM$(LCASE$(dplayername(a)))) <> "none") THEN
               xsprint 120 + (b * 15), 35, dplayername(a) + "  HP:" + STR$(dplayerhp(a)) + "/" + STR$(dplayermhp(a)) + "   Lv." + STR$(dplayerlevel(a)), 1
               xsprint 135 + (b * 15), 35, "MP:" + STR$(dplayermp(a)) + "/" + STR$(dplayermmp(a)) + "   EXP:" + STR$(dplayerexp(a)), 1
               b = b + 1
            END IF
            'b = b + 1
         NEXT a
      CASE 5 'Player exit
         
         xsprint 52, 35, "Exit?", 2
         
         IF subchoice > 1 THEN subchoice = 0
         IF subchoice < 0 THEN subchoice = 1
         
         xsprint 67, 35, "Yes", 31 * -(subchoice = 1)
         xsprint 80, 35, "No", 31 * -(subchoice = 0)
         
         
         
      END SELECT
      
   WEND
END SUB

SUB moveobject (psprite, MinorX, MinorY)
   DIM b AS LONG
   DIM c AS LONG
   DIM d AS LONG
   
   IF psprite = players(1).sprite THEN scriptedobject = 0
   hitsprite = 0
   
   
   
   check3 = objects(psprite, 3)  'accessing the array is actually fairly slow
   'so I'll just put it into a 0d array (?)
   BaseDetected = 0
   
   IF MinorX THEN
      IF objects(psprite, 4) + MinorX > tilesize THEN
         IF map(objects(psprite, 1) + 1, objects(psprite, 2) + 1) > 7 THEN BaseDetected = -1
         IF map(objects(psprite, 1) + 1, objects(psprite, 2)) > 7 THEN BaseDetected = -1
         IF map(objects(psprite, 1) + 2, objects(psprite, 2)) > 7 THEN BaseDetected = -1
         IF map(objects(psprite, 1) + 2, objects(psprite, 2) + 1) > 7 THEN BaseDetected = -1
         
         
         
         
         
      ELSEIF objects(psprite, 4) + MinorX < 1 THEN
         IF map(objects(psprite, 1) - 1, objects(psprite, 2) + 1) > 7 THEN BaseDetected = -1
         IF map(objects(psprite, 1) - 1, objects(psprite, 2)) > 7 THEN BaseDetected = -1
         
         IF map(objects(psprite, 1), objects(psprite, 2) + 1) > 7 THEN BaseDetected = -1
         IF map(objects(psprite, 1), objects(psprite, 2)) > 7 THEN BaseDetected = -1
         
         
      END IF
      
      
      
      
   END IF
   
   IF MinorY THEN
      'objects(psprite, 5) + Minory
      IF objects(psprite, 5) + MinorY > tilesize THEN
         IF map(objects(psprite, 1), objects(psprite, 2) + 1) > 7 THEN BaseDetected = -1
         IF map(objects(psprite, 1) + 1, objects(psprite, 2) + 1) > 7 THEN BaseDetected = -1
         
         IF map(objects(psprite, 1), objects(psprite, 2) + 2) > 7 THEN BaseDetected = -1
         IF map(objects(psprite, 1) + 1, objects(psprite, 2) + 2) > 7 THEN BaseDetected = -1
         
         
         
      ELSEIF objects(psprite, 5) + MinorY < 1 THEN
         
         IF map(objects(psprite, 1), objects(psprite, 2) - 1) > 7 THEN BaseDetected = -1
         IF map(objects(psprite, 1) + 1, objects(psprite, 2) - 1) > 7 THEN BaseDetected = -1
         
         IF map(objects(psprite, 1), objects(psprite, 2)) > 7 THEN BaseDetected = -1
         IF map(objects(psprite, 1) + 1, objects(psprite, 2)) > 7 THEN BaseDetected = -1
         
      END IF
      
      
   END IF
   
   
   
   
   
	lastused = 0
   
   'cdetect1   Check 1<*> Check 2<*>
   IF MinorX > 0 THEN
		IF BaseDetected THEN lastused = 1
   END IF
   'cdetect 2  Check 1<*> Check 2<*>
   IF MinorX < 0 THEN
		IF BaseDetected THEN lastused = 2
   END IF
   
   'Cdetect 3 Check1<*> Check2<*>
   IF MinorY > 0 THEN 'This was 0 before, but I disabled this one.
		IF BaseDetected THEN lastused = 3
   END IF
   
   'cdetect 4: Check1<*> Check2<*>
	IF MinorY < 0 THEN
		IF BaseDetected THEN lastused = 4
   END IF
   'This is the sprite detection. Fix it later for the better.
   
   HitaScript = 0
   here = 0
   
   FOR a = -100 TO 140
      'IF psprite <> a THEN
      IF objects(a, 7) <> 100 THEN
         'sprite collision detection
         'until further notice, all sprites are checked.
         
         'Checks to see if it's even worth checking first.
         BigAdifference = ABS(objects(a, 1) - objects(psprite, 1))
         bigBdifference = ABS(objects(a, 2) - objects(psprite, 2))
         
         IF (BigAdifference < 3) AND (bigBdifference < 3) THEN
            
            b = MultByTileSize(objects(a, 1)) + ((objects(a, 4))) - tilesize
            c = MultByTileSize(objects(psprite, 1)) + ((objects(psprite, 4) + (MinorX)))
            'd = (objects(psprite, 1) * 20) + ((objects(psprite, 4) + MinorX + 17))
            
            'OR b = d
            d = c - (b + tilesize)
            
            
            IF ((c - b) > 0) AND d < tilesize THEN
               
               b = MultByTileSize(objects(a, 2)) + ((objects(a, 5))) - tilesize
               c = MultByTileSize(objects(psprite, 2)) + ((objects(psprite, 5) + (MinorY)))
               'd = (objects(psprite, 2) * 20) + ((objects(psprite, 5) + MinorY + 17))
               
               
               
               'OR ((b - d) < 20)
               
               d = c - (b + tilesize)
               
               IF ((c - b) > 0) AND d < tilesize THEN
                  HitaScript = 1
                  IF objects(a, 3) <> -30 THEN
                     IF objects(a, 3) <> 50 AND objects(a, 3) <> 0 THEN
                        
                        IF lastused = 0 AND a <> psprite THEN
                           lastused = 5
                           
                           
                           IF psprite = players(1).sprite THEN scriptedobject = a
                        END IF
                     ELSEIF objects(a, 3) = 50 THEN
                        IF a <> psprite THEN
                           IF psprite = players(1).sprite THEN scriptedobject = a
                        END IF
                        
                     END IF
                  END IF
                  
               END IF
            END IF
            
            
            'The script detection. now I (hope I :)) save a lot of CPU time by just
            'skipping the second check
            
            IF psprite = 1 THEN                    'The script detection.
               IF HitaScript = 1 THEN
                  IF objects(a, 3) = -30 THEN
                     ResetKeys
                     
                     Script objects(a, 6)
                  END IF
                  
               END IF
               HitaScript = 0
               
               
            END IF
         END IF
      END IF
   NEXT a
   
   
   IF lastused = 0 THEN
      
      IF MinorX THEN
         CachedPos = MinorX + objects(psprite, 4)
         IF CachedPos > tilesize OR CachedPos < 0 THEN
            temp = MultByTileSize(objects(psprite, 1)) + CachedPos
            objects(psprite, 1) = temp \ tilesize
            objects(psprite, 4) = temp MOD tilesize
         ELSE
            objects(psprite, 4) = CachedPos
         END IF
      END IF
      
      IF MinorY THEN
         CachedPos = MinorY + objects(psprite, 5)
         IF CachedPos > tilesize OR CachedPos < 0 THEN
            temp = MultByTileSize(objects(psprite, 2)) + CachedPos
            objects(psprite, 2) = temp \ tilesize
            objects(psprite, 5) = temp MOD tilesize
         ELSE
            objects(psprite, 5) = CachedPos
         END IF
      END IF
   END IF
   
   
   
   IF psprite = Focus THEN CameraFocus Focus
   
   
END SUB

SUB MoveTransition ()
   
END SUB

SUB MoveWater ()
   
END SUB

SUB nControl ()
   
   DIM ControlledObject AS INTEGER
   
   ControlledObject = 1
   'WHILE LEN(INKEY$): WEND
   DIM button(4) AS INTEGER
   
   'digitalJstk up, down, lleft, right, button()
   'Sets the keys(duh...)
   
   '    WHILE INKEY$ <> "": WEND'Just wait until the buffer is empty.
   
   lastused = 0
   
   'CASE Uparrow
   StepTimes = 8
   
   walkspeed = 2
   
	objects(ControlledObject, 7) = 0
   
   IF keyflag(Uparrow) OR up THEN
	   lastwasnotspace = 0
	   LastDirection = 1
	   lastwasnotspace = 0
      
      objects(ControlledObject, 7) = 6
   END IF
   
   
   IF keyflag(Dnarrow) OR down THEN
	   lastwasnotspace = 0
	   LastDirection = 2
	   lastwasnotspace = 0
      
      objects(ControlledObject, 7) = 7
   END IF
   
   IF keyflag(rarrow) THEN
      lastwasnotspace = 0
      LastDirection = 4
      
      objects(ControlledObject, 7) = 9
   END IF
   
   IF keyflag(larrow) THEN
      lastwasnotspace = 0
      LastDirection = 3
      
      objects(ControlledObject, 7) = 8
   END IF
   
   
   IF (keyflag(Uparrow) OR up) AND (keyflag(rarrow)) THEN
      lastwasnotspace = 0
      LastDirection = 1
      lastwasnotspace = 0
      
      objects(ControlledObject, 7) = 11
   END IF
   IF (keyflag(Dnarrow) OR down) AND (keyflag(larrow)) THEN
      lastwasnotspace = 0
      LastDirection = 1
      lastwasnotspace = 0
      objects(ControlledObject, 7) = 12
   END IF
   IF (keyflag(Dnarrow) OR down) AND (keyflag(rarrow)) THEN
      lastwasnotspace = 0'
      LastDirection = 1
      lastwasnotspace = 0
      
      objects(ControlledObject, 7) = 13
   END IF
   IF (keyflag(uparrow) AND keyflag(larrow)) OR (up AND lleft) THEN
      lastwasnotspace = 0
      LastDirection = 1
      lastwasnotspace = 0
      
      objects(ControlledObject, 7) = 10
   END IF
   
   IF (keyflag(Spacebar) OR button(1)) AND lastwasnotspace = 0 THEN
      lastwasnotspace = 20
      ResetKeys
      a = scriptedobject
      IF objects(a, 6) <> 0 THEN
         ScriptCalledFromSprite = a
         ConsoleMSG "Script" + STR$(objects(a, 6)) + " called from :" + STR$(a)
         ScriptSpot = objects(a, 6)
         Script ScriptSpot
      END IF
      
   END IF
   IF lastwasnotspace THEN lastwasnotspace = lastwasnotspace - 1
   ' CASE Esc
   IF keyflag(Esc) OR button(3) AND lastwasnotspace = 0 THEN
      lastwasnotspace = 20
      ResetKeys
      menuActive
   END IF
   IF keyflag(96) AND lastwasnotspace = 0 THEN
      lastwasnotspace = 20
      
      ResetKeys
      console page, objects(), people()
   END IF
   
   'END SELECT
   
   
END SUB

SUB nFileRead ()
   DIM filenum AS INTEGER
   DIM record AS LONG
   filenum = FREEFILE
   
   'OPEN ".\data\backtil1.spr" FOR BINARY AS #filenum
   'record = 1
   'FOR a = -36 TO 40
   ' FOR y = 1 TO tilesize
   '  FOR x = 1 TO tilesize
   '    GET #filenum, record, Marker
   '    IF Marker <> 0 THEN sprite(x, y, a) = Marker AND 255
   '    record = record + 1
   '  NEXT x, y
   'NEXT a
   'CLOSE #filenum
   
   
   objects(1, 10) = 1
   
END SUB

SUB nocdmoveobject (byval psprite as integer,byval MinorX as integer,byval MinorY as integer)
   sssss = psprite
   
   DIM temp AS SINGLE
	CachedPos = MinorX + objects(psprite, 4)
   
   
   temp = MultByTileSize(objects(sssss, 1)) + CachedPos
   objects(sssss, 1) = temp \ tilesize
   objects(sssss, 4) = temp MOD tilesize
   
	CachedPos = MinorY + objects(psprite, 5)
   
	temp = MultByTileSize(objects(sssss, 2)) + CachedPos
	objects(sssss, 2) = temp \ tilesize
	objects(sssss, 5) = temp MOD tilesize
   
   'IF Focus = psprite THEN CameraFocus (Focus)
   
END SUB

SUB objectbehave ()
   
   FOR a = -100 TO 140
      WHILE (objects(a, 7) = 0) AND a < 140
         a = a + 1
      WEND
      
      IF a = 140 THEN EXIT FOR
      
      SELECT CASE objects(a, 7)
      CASE 60 'the "headbanger" prose. :P
         IF objects(a, 9) = 0 THEN
            objects(a, 3) = objects(a, 3) + 1
            objects(a, 9) = 30'15 + INT(RND(1) * 30)
         END IF
         IF objects(a, 9) = 15 THEN
            objects(a, 3) = objects(a, 3) - 1
         END IF
         
         objects(a, 9) = objects(a, 9) - 1
      CASE 100 'was a wait.Now it's follow the selected character like a lostdog
         
         '(Spritenumber, Sprite2number, Shift)
         
         Spritenumber = a
         Sprite2number = objects(a, 8)
         
         sssss = Spritenumber
         
         
         IF Spritenumber >= 1 AND Spritenumber <= 3 THEN KKJ = Spritenumber
         IF Sprite2number >= 1 AND Sprite2number <= 3 THEN KKJ = Sprite2number
         
         DIM slopex AS SINGLE
         DIM slopey AS SINGLE
         
         'DIM steps AS INTEGER
         DIM Xone AS SINGLE
         DIM Yone AS SINGLE
         DIM Xtwo AS SINGLE
         DIM Ytwo AS SINGLE
         
         Xone = (objects(Spritenumber, 1) * tilesize) + objects(Spritenumber, 4) - 10
         Yone = (objects(Spritenumber, 2) * tilesize) + objects(Spritenumber, 5) - 10
         
         Xtwo = (objects(Sprite2number, 1) * tilesize) + objects(Sprite2number, 4) - 10
         Ytwo = (objects(Sprite2number, 2) * tilesize) + objects(Sprite2number, 5) + Shift - 10
         
         
         
         'steps = (ABS(Xone - Xtwo) + ABS(Yone - Ytwo)) \ 10
         
         
         'steps = (ABS(Xone - Xtwo) + ABS(Yone - Ytwo)) \ 10
         pdistance = ((ABS(Xone - Xtwo) ^ 2) + (ABS(Yone - Ytwo) ^ 2)) ^ .5
         
         
         
         
         
         slopex = (Xtwo - Xone) / tilesize
         slopey = (Ytwo - Yone) / tilesize
         
         
         'hehehe walking sprites for the second guy
         '(am I evil? YES I AM)
         objects(a, 9) = objects(a, 9) + 1
         
         IF objects(a, 9) < (tilesize/2) THEN x = 1 ELSE x = 2
         IF objects(a, 9) > tilesize THEN objects(a, 9) = 0
         
         
         IF pdistance > 30 THEN
            
            IF ABS(slopex) > ABS(slopey) THEN
               IF slopex > 0 THEN
                  objects(a, 3) = people(objects(a, 10)).left(x)
                  
               END IF
               IF slopex < 0 THEN
                  
                  objects(a, 3) = people(objects(a, 10)).right(x)
                  
                  
               END IF
            END IF
            
            
            IF ABS(slopey) > ABS(slopex) THEN
               
               IF slopey > 0 THEN
                  objects(a, 3) = people(objects(a, 10)).down(x)
                  
               END IF
               IF slopey < 0 THEN
                  
                  objects(a, 3) = people(objects(a, 10)).up(x)
                  
                  
               END IF
               
               
               
               
            END IF
            
            
            
            
            
            
            nocdmoveobject sssss, slopex, slopey
            
            
            IF ABS(Xtwo - Xone) < tilesize THEN
               IF ABS(Xtwo - Xone) <> 0 THEN
                  
                  IF (Xtwo - Xone) > 0 THEN
                     nocdmoveobject sssss, 1, 0
                  END IF
                  
                  IF (Xtwo - Xone) < 0 THEN
                     nocdmoveobject sssss, -1, 0
                  END IF
                  
                  
               END IF
               
               
            END IF
            
            IF ABS(Ytwo - Yone) < tilesize THEN
               IF ABS(Ytwo - Yone) <> 0 THEN
                  
                  IF (Ytwo - Yone) > 0 THEN
                     nocdmoveobject sssss, 0, 1
                  END IF
                  
                  IF (Ytwo - Yone) < 0 THEN
                     nocdmoveobject sssss, 0, -1
                  END IF
                  
                  
               END IF
               
               
            END IF
            
            
         END IF
         
         
         
         
      CASE 6
         'Person walking. Up variation.
         
         objects(a, 9) = objects(a, 9) + 1
         
         IF objects(a, 9) < (tilesize/2) THEN x = 1 ELSE x = 2
         IF objects(a, 9) > tilesize THEN objects(a, 9) = 0
         
         moveobject a, 0, -2
         
         objects(a, 3) = people(objects(a, 10)).up(x)
         
         
      CASE 7
         'Person walking. down variation.
         
         
         objects(a, 9) = objects(a, 9) + 1
         
         IF objects(a, 9) < tilesize/2 THEN x = 1 ELSE x = 2
         IF objects(a, 9) > tilesize THEN objects(a, 9) = 0
         
         IF objects(a, 3) <> people(objects(a, 10)).down(1) OR objects(a, 3) <> people(objects(a, 10)).down(2) THEN
            objects(a, 3) = people(objects(a, 10)).down(1)
         END IF
         
         moveobject a, 0, 2
         
         objects(a, 3) = people(objects(a, 10)).down(x)
         
      CASE 8
         'Person walking. left variation.
         
         
         
         objects(a, 9) = objects(a, 9) + 1
         
         IF objects(a, 9) < (tilesize/2) THEN x = 1 ELSE x = 2
         IF objects(a, 9) > tilesize THEN objects(a, 9) = 0
         
         moveobject a, -2, 0
         
         objects(a, 3) = people(objects(a, 10)).left(x)
         
         
         
         
      CASE 9
         'Person walking. right variation.
         
         
         
         objects(a, 9) = objects(a, 9) + 1
         
         IF objects(a, 9) < tilesize/2 THEN x = 1 ELSE x = 2
         IF objects(a, 9) > tilesize THEN objects(a, 9) = 0
         
         
         moveobject a, 2, 0
         
         objects(a, 3) = people(objects(a, 10)).right(x)
      CASE 10
         'Person walking. Up/left variation.
         
         objects(a, 9) = objects(a, 9) + 1
         
         IF objects(a, 9) < tilesize/2 THEN x = 1 ELSE x = 2
         IF objects(a, 9) > tilesize THEN objects(a, 9) = 0
         
         moveobject a, -2, -2
         
         objects(a, 3) = people(objects(a, 10)).left(x)
         
         
      CASE 11
         'Person walking. up/right variation.
         
         
         objects(a, 9) = objects(a, 9) + 1
         
         IF objects(a, 9) < tilesize/2 THEN x = 1 ELSE x = 2
         IF objects(a, 9) > tilesize THEN objects(a, 9) = 0
         
         IF objects(a, 3) <> people(objects(a, 10)).right(1) OR objects(a, 3) <> people(objects(a, 10)).down(2) THEN
            objects(a, 3) = people(objects(a, 10)).right(1)
         END IF
         
         moveobject a, 2, -2
         
         objects(a, 3) = people(objects(a, 10)).right(x)
         
      CASE 12
         'Person walking. down/left variation.
         
         
         
         objects(a, 9) = objects(a, 9) + 1
         
         IF objects(a, 9) < tilesize/2 THEN x = 1 ELSE x = 2
         IF objects(a, 9) > tilesize THEN objects(a, 9) = 0
         
         moveobject a, -2, 2
         
         objects(a, 3) = people(objects(a, 10)).left(x)
         
         
         
         
      CASE 13
         'Person walking. down/right variation.
         
         
         
         objects(a, 9) = objects(a, 9) + 1
         
         IF objects(a, 9) < tilesize/2 THEN x = 1 ELSE x = 2
         IF objects(a, 9) > tilesize THEN objects(a, 9) = 0
         
         
         
         moveobject a, 2, 2
         
         objects(a, 3) = people(objects(a, 10)).right(x)
         
         
      CASE -1 'Negatives will be AI behaviours.
			'This is at least part of the patrol behaviour.
			'left/right patrol, 90 degree turns.
			IF objects(a, 10) = 0 THEN objects(a, 10) = objects(a, 3)
         
         IF objects(a, 9) = 0 THEN
            moveobject a, 1, 0
            getLastUsed x
            
            IF x THEN
               objects(a, 9) = 30
               objects(a, 3) = objects(a, 10) + 1
               
            END IF
         END IF
         
         IF objects(a, 9) = 1 THEN
            moveobject a, -1, 0
            getLastUsed x
            
            IF x THEN
               objects(a, 3) = objects(a, 10)
               
               objects(a, 9) = -30
               
               
            END IF
         END IF
         
         IF objects(a, 9) > 1 THEN
            objects(a, 9) = objects(a, 9) - 1
            
         END IF
         IF objects(a, 9) < 0 THEN
            objects(a, 9) = objects(a, 9) + 1
            
         END IF
         
      CASE -2 'Negatives will be AI behaviours.
			'This is at least part of the patrol behaviour.
			'left/right patrol, 90 degree turns.
         IF objects(a, 9) = 0 THEN
            moveobject a, 0, 1
            getLastUsed x
            
            IF x THEN
               
               objects(a, 9) = 30
               
            END IF
         END IF
         
         IF objects(a, 9) = 1 THEN
            moveobject a, 0, -1
            getLastUsed x
            
            IF x THEN
               
               objects(a, 9) = -30
               
            END IF
         END IF
         
         IF objects(a, 9) > 1 THEN
            objects(a, 9) = objects(a, 9) - 1
            
         END IF
         IF objects(a, 9) < 0 THEN
            objects(a, 9) = objects(a, 9) + 1
            
         END IF
         
      CASE -1 'Negatives will be AI behaviours.
			'This is at least part of the patrol behaviour.
			'left/right patrol, 90 degree turns.
         IF objects(a, 9) = 0 THEN
            moveobject a, 1, 0
            getLastUsed x
            
            IF x THEN
               
               objects(a, 9) = 30
               objects(a, 3) = objects(a, 3) + 1
               
               
            END IF
         END IF
         
         IF objects(a, 9) = 1 THEN
            moveobject a, -1, 0
            getLastUsed x
            
            IF x THEN
               objects(a, 3) = objects(a, 3) - 1
               objects(a, 9) = -30
               
            END IF
         END IF
         
         IF objects(a, 9) > 1 THEN
            objects(a, 9) = objects(a, 9) - 1
            
         END IF
         IF objects(a, 9) < 0 THEN
            objects(a, 9) = objects(a, 9) + 1
            
         END IF
         
      CASE -2 'Negatives will be AI behaviours.
			'This is at least part of the patrol behaviour.
			'left/right patrol, 90 degree turns.
         IF objects(a, 9) = 0 THEN
            moveobject a, 0, 1
            getLastUsed x
            
            IF x THEN
               
               objects(a, 9) = 30
               
            END IF
         END IF
         
         IF objects(a, 9) = 1 THEN
            moveobject a, 0, -1
            getLastUsed x
            
            IF x THEN
               
               objects(a, 9) = -30
               
            END IF
         END IF
         
         IF objects(a, 9) > 1 THEN
            objects(a, 9) = objects(a, 9) - 1
            
         END IF
         IF objects(a, 9) < 0 THEN
            objects(a, 9) = objects(a, 9) + 1
            
         END IF
      CASE -11 'Negatives will be AI behaviours.
			'This is at least part of the patrol behaviour.
			'left/right patrol, 90 degree turns. Sight active.
         IF objects(a, 9) = 0 THEN
            moveobject a, 1, 0
            getLastUsed x
            
            IF x THEN
               
               objects(a, 9) = 30
               
            END IF
         END IF
         
         IF objects(a, 9) = 1 THEN
            moveobject a, -1, 0
            getLastUsed x
            
            IF x THEN
               
               objects(a, 9) = -30
               
            END IF
         END IF
         
         IF objects(a, 9) > 1 THEN
            objects(a, 9) = objects(a, 9) - 1
            
         END IF
         IF objects(a, 9) < 0 THEN
            objects(a, 9) = objects(a, 9) + 1
            
         END IF
         
      CASE -12 'Negatives will be AI behaviours.
			'This is at least part of the patrol behaviour.
			'left/right patrol, 90 degree turns, sight active.
         IF objects(a, 9) = 0 THEN
            moveobject a, 0, 1
            getLastUsed x
            
            IF x THEN
               
               objects(a, 9) = 30
               
            END IF
         END IF
         
         IF objects(a, 9) = 1 THEN
            moveobject a, 0, -1
            getLastUsed x
            
            IF x THEN
               
               objects(a, 9) = -30
               
            END IF
         END IF
         
         IF objects(a, 9) > 1 THEN
            objects(a, 9) = objects(a, 9) - 1
            
         END IF
         IF objects(a, 9) < 0 THEN
            objects(a, 9) = objects(a, 9) + 1
            
         END IF
         
      END SELECT
      
   NEXT a
   
   
   
END SUB

SUB omap (x, y, Result)
   Result = map(x, y)
   
END SUB



SUB palatte (colr, r, g, b)
   'skipthisframe = 1
   
   'pall(colr, 1) = r
   'pall(colr, 2) = g
   'pall(colr, 3) = b
   
   
END SUB

SUB PlayerAttack (a)
   '   SHARED x, y
	
	'This is here just because I reused this code.
	attack = 1
	'predetermines the target of the attack.
	'Makes sure that the target actually exists and is alive.
	target = PlayerTargetSelect
	IF target = 0 THEN
      cancelled = 1
      
      EXIT SUB
   END IF
	'This will not reset the time if the user cancels the action.
	players(a).time = 0
   
   
	IF attack = 1 THEN
      'This beauty is the attack power.
      attacks = players(a).attack + (players(a).attack * (RND(1) * 2))
      attacks = INT(attacks)
	   
      'If the attack will kill the player, it changes the attack to the HP.
      'IF attacks <= enemies(target).defence THEN miss = 1 ELSE miss = 0
      attaks = attacks - enemies(target).defence
      IF attaks <= 0 THEN miss = 1: miss = 0
      linemove players(a).sprite, enemies(target).sprite, 15
      
      IF miss = 1 THEN
         CombatMessage "Missed"
         fullredraw
         PrintOnObject enemies(target).sprite, "Missed", 31
         battlebox
         pageflip
         Drawbattlemenu
         bpwait .5, enemies(target).sprite, "Missed"
		   
         EXIT SUB 'the easy way to kill this whole thing off if you miss.
      ELSE
         attacks = attacks - enemies(target).defence
      END IF
      
      IF attacks > enemies(target).hp THEN
         oa = attacks - enemies(target).hp
         attacks = 0
         enemies(target).hp = 0
         enemies(target).exists = False
         fullredraw
         PrintOnObject enemies(target).sprite, STR$(oa), 31
         
         battlebox
         Drawbattlemenu
         pageflip
         '       bpwait (.5), enemies(target).sprite, STR$(oa)
         
         EXIT SUB
      END IF
      enemies(target).hp = enemies(target).hp - attacks
	   
		fullredraw
		PrintOnObject enemies(target).sprite, STR$(attacks), 31
      
		battlebox
		Drawbattlemenu
      
		pageflip
      bpwait .5, enemies(target).sprite, STR$(attacks)
      
      'CombatMessage STR$(attacks) + " Damage"
   ELSE
      'battlescript players(a).sname, INT(attack), INT(a), "Player"
      
   END IF
   
   
END SUB

FUNCTION playersbattling ()
   
   FOR a = 1 TO 3
      IF players(a).exists = True THEN
         existingplayers = existingplayers + 1
      END IF
   NEXT a
   playersbattling = existingplayers
   
END FUNCTION

DEFINT A-Z
SUB PlayersCalculate (players() AS Player)
   
   DIM pe AS DOUBLE
   
   FOR a = 1 TO 3
      
      Fakestring$ = LTRIM$(RTRIM$(LCASE$(players(a).sname)))
      IF Fakestring$ = "none" THEN
         players(a).exists = False
         players(a).dead = True
      ELSE
         IF players(a).Experience = 0 THEN players(a).Experience = 2
         IF players(a).hp = 0 THEN players(a).hp = 1
         
         players(a).dead = False
         pe = players(a).Experience
         players(a).level = ((((pe) / ((pe) ^ .25))) * ((1 / (-pe)) + .0031)) * 1.5 + 1
         '((players(a).Experience) * 2) ^ .25
         players(a).maxhp = 45 + ((players(a).level * 60))
         IF players(a).maxhp >= 9999 THEN players(a).maxhp = 9999
         
         players(a).maxmp = 5 + (players(a).level * 8)
         IF maxmp > 9999 THEN maxmp = 9999
         '      players(a).mp = players(a).maxmp
         
         
         players(a).speed = players(a).level * 1.5
         
         players(a).attack = 10 + (players(a).level * 3.6)
         players(a).defence = 10 + players(a).level * 4
         
         'This stuff should be set at startup.
         players(a).dead = False
         players(a).exists = True
      END IF
   NEXT a
   
END SUB

FUNCTION PlayerTargetSelect ()
   
   DIM button(4) AS INTEGER
   LeftKey$ = chr$(lArrow)
   RightKey$ = chr$(rArrow)
   UpKey$ = chr$(upArrow)
   Downkey$ = chr$(dnArrow)
   BackKey$ = CHR$(27)
   
   notchosen = -1
   t = 1
   
   'gives you time to release the button
   ' digitalJstk up, down, left, right, button()
   
   
   
   
   WHILE (notchosen)
      'Read the input and empty the buffer.
      'MTKInkey key$
      key$ = ggetkey$
      
      'more of that lovely hacking
      '   digitalJstk up, down, left, right, button()
      IF up THEN key$ = UpKey$
      IF down THEN key$ = Downkey$
      '   IF left THEN key$ = LeftKey$
      '   IF right THEN key$ = RightKey$
      
      IF button(1) THEN key$ = " "
      IF button(4) THEN key$ = BackKey$
      
      
      '**First, we see where the user *wants* to go.
      SELECT CASE key$
      CASE " " ' space.
         notchosen = 0
      CASE Downkey$
         t = t - 1
         dn = 1
      CASE UpKey$
         t = t + 1
      CASE RightKey$
         t = t - 1
         dn = 1
      CASE LeftKey$
         t = t + 1
      CASE CHR$(8)'Backspace(why not?).
         
         'mirror the next one.
         objects(137, 1) = 0
         objects(137, 2) = 0
         objects(137, 3) = 0
         objects(137, 4) = 0
         objects(137, 5) = 0
         
         
         PlayerTargetSelect = 0
         EXIT FUNCTION
      CASE BackKey$
         
         objects(137, 1) = 0
         objects(137, 2) = 0
         objects(137, 3) = 0
         objects(137, 4) = 0
         objects(137, 5) = 0
         
         PlayerTargetSelect = 0
         EXIT FUNCTION
         
         'return 0, exit sub, tell other sub not to do anything.
         'And don't remove the players built up time.
         
      END SELECT
		IF t = 0 THEN t = 3
		IF t = 4 THEN t = 1
      
      'If the enemy doesn't exist there, keep shifting to find one.
      IF dn = 0 THEN
         WHILE enemies(t).exists = 0
            t = t + 1
            IF t = 4 THEN t = 1
         WEND
      ELSE
         WHILE enemies(t).exists = 0
            t = t - 1
            IF t = 0 THEN t = 3
         WEND
      END IF
      
      'Pointer:Everywhere you want to be :)
      objects(137, 1) = objects(enemies(t).sprite, 1)
      objects(137, 2) = objects(enemies(t).sprite, 2)
      objects(137, 3) = 47
      objects(137, 4) = objects(enemies(t).sprite, 4)
      objects(137, 5) = objects(enemies(t).sprite, 5)
      
      fullredraw
      battlebox
      statsint
      renderbattlemenu
      
      pageflip
      
      
      
   WEND
	'Reseting the pointer object (we'll need it)
	'and getting out of this sub.
   objects(137, 1) = 0
   objects(137, 2) = 0
   objects(137, 3) = 0
   objects(137, 4) = 0
   objects(137, 5) = 0
   PlayerTargetSelect = t
   
   
   
END FUNCTION

SUB PrintOnObject (number, text$, colr)
   xx = (MultByTileSize(objects(number, 1)) + objects(number, 4)) + pvpvarx
   yy = (MultByTileSize(objects(number, 2)) + objects(number, 5)) + pvpvary
   'IF yy < 240 AND yy + TILESIZE > -1 AND xx < 320 AND xx > -1 THEN
   shadowdrop = 1
   xsprint yy/2, xx/2, text$, 16
   shadowdrop = 0
   
   xsprint yy/2, xx/2, text$, colr
   'END IF
END SUB

SUB pscroll (r, g, b, steps)
   
   FOR a = 0 TO steps
      if (R + g + B) < 0 then  xcls a
      pageflip
      
   NEXT a
   
END SUB

SUB PSET8bit (x AS INTEGER, y AS INTEGER, colr AS INTEGER)
   if colr = 0 then exit sub
   DIM r AS uinteger
   DIM g AS uinteger
   DIM b AS uinteger
   r = (pall(colr, 1) * 4) and 255
   g = (pall(colr, 2) * 4) and 255
   b = (pall(colr, 3) * 4) and 255
   
   
   dim ShittyRect as SDL_Rect
   shittyrect.x = x shL 1
   shittyrect.y = y shL 1
   shittyrect.w = 2
   shittyrect.h = 2
   
   SDL_FillRect omaScreenSurface, @shittyRect, SDL_MapRGB(omaScreenSurface->format, r, g, b)
	
   
END SUB

SUB putd (sx, sy, colr)
   'DEFINT A-Z
	IF colr <> 0 then
      PSET8bit sx, sy, colr
   END IF
   
END SUB

SUB pwait (a!)
   DIM oldtimer
   oldtimer = SDL_GetTicks() + (a! * 1000)
   
   WHILE  oldtimer > SDL_GetTicks()
      PageFlip()
      sleep 0
   WEND
   
END SUB

FUNCTION ReadLine$ (playa AS INTEGER, attack AS INTEGER, lin AS INTEGER)
   
	DIM PlayerName AS STRING
   
	PlayerName = players(playa).sname
	PlayerName = LTRIM$(RTRIM$(PlayerName))
   
   
	DIM filn AS INTEGER
   
	filn = FREEFILE
   
	OPEN "battles1.jss" FOR INPUT AS filn
   
   
	DIM lien AS STRING
	lien = ""
   
	WHILE (lien <> PlayerName AND NOT EOF(filn))
      INPUT #filn, lien
   WEND
   
	lien = ""
	WHILE (lien <> "attack " + LTRIM$(RTRIM$(STR$(attack))))
      IF NOT EOF(filn) THEN INPUT #filn, lien
      lien = LTRIM$(RTRIM$(LCASE$(lien)))
      IF lien = "end " + PlayerName OR EOF(filn) THEN
         'this is what happens if we reach the end.
         lien = "Out of Bounds"
         CLOSE #filn
         ReadLine = lien
         EXIT FUNCTION
      END IF
      
   WEND
   
	lin = lin + 1
	FOR a = 1 TO lin
      IF NOT EOF(filn) THEN INPUT #filn, lien
      IF GetParameter$(lien, 1) = "end" OR LEFT$(lien, 5) = "attack" THEN
         'this is what happens if we reach the end.
         lien = "Out of Bounds"
         CLOSE #filn
         ReadLine = lien
         EXIT FUNCTION
      END IF
   NEXT a
   
	ReadLine = lien
	CLOSE #filn
END FUNCTION

SUB renderbattlemenu () '(colorgrid())
   
   DIM colorgrid(1 TO 3, 1 TO 4)
   
   
	FOR osss = 1 TO 0 STEP -1
      FOR a = 1 TO 3
         FOR b = 1 TO 4
            colorgrid(a, b) = 31 * ABS(osss - 1)
         NEXT b
         IF players(a).dead = 1 THEN players(a).ready = 0
         IF players(a).dead = 1 THEN objects(players(a).sprite, 3) = 0
      NEXT a
      colorgrid(battleX, battley) = BattleCursorColor * ABS(osss - 1)
      
      shadowdrop = osss
      
      FOR xyz = 1 TO 3
         IF players(xyz).exists = True THEN
            IF players(xyz).ready = True THEN
               xsprint 180, (75 * (xyz - 1)), "Attack", colorgrid(xyz, 1)
               xsprint 192, (75 * (xyz - 1)), "Defend", colorgrid(xyz, 2)
               xsprint 204, (75 * (xyz - 1)), "Magic", colorgrid(xyz, 3)
               xsprint 216, (75 * (xyz - 1)), "Item", colorgrid(xyz, 4)
            END IF
            
            
            xsprint 168, (75 * (xyz - 1)), players(xyz).sname, 2 * ABS(osss - 1)
            
            xsprint 228, (75 * (xyz - 1)), LTRIM$(RTRIM$(STR$(players(xyz).hp) + "/" + STR$(players(xyz).maxhp))), 2 * ABS(osss - 1)
         END IF
      NEXT xyz
   NEXT osss
	reimplemented = 0
   
END SUB

SUB renderobjects ()
   'Note: This is now slower, but looks better -- I hope.
   
   
   sortobjects            'Needed for the newly more efficient renderer.
   
   here = 4 'by carefully placing these statements, I have avoided an IF. NEATO
   
   FOR dagga = 1 TO 3
      WHILE (ObjectBuffer(here, 1) <> 256)
         'addToDebug "running through buffer at "; here
         IF ObjectBuffer(here, 2) = dagga THEN
            
            a = ObjectBuffer(here, 1)
            
            xx = MultByTileSize(objects(a, 1)) + objects(a, 4) + pvpvarx
            
            yy = (MultByTileSize(objects(a, 2)) + objects(a, 5) + pvpvary)
            
            CurrentTile = objects(a, 3)
            IF CurrentTile <> 0 THEN
               omaqfakBlitImage xx  ,yy, CurrentTile - 1 , spriteBitmap 
            END IF
         END IF
         here = here + 1
      WEND
      
      here = 0
   NEXT dagga
   
   'RENDER THE PALETTE OVERLAY
   
   PaletteOverlay
   
END SUB
sub PaletteOverlay
  
   if NightFall = 1 then
      static ShittyRect as SDL_Rect
      dim ShittySurface as SDL_Surface PTR
      static ConvertedFile as SDL_Surface ptr
      
      if ConvertedFile = 0 then
   
   omaGetScreenDimensions w, h       
         shittyrect.w = w
         shittyrect.h = h
         ShittySurface = SDL_CreateRGBSurface( SDL_SRCALPHA, shittyrect.w + 2, shittyrect.h, 32, 0,0,0, 0)
         ConvertedFile = SDL_DisplayFormat(ShittySurface)     
         omaKillSurface ShittySurface
         SDL_fillRect ConvertedFile, @shittyRect, SDL_MapRGB(omaScreenSurface->Format, 0, 0, 64)
         SDL_SetAlpha ConvertedFile, SDL_SRCALPHA, 128
         
      end if
      
      omaBlitImage 0, 0, Convertedfile
      
   end if
   
end sub

SUB ResetKeys ()
END SUB

SUB save (x)
   
   fileno = FREEFILE
   OPEN ".\save\save" + LTRIM$(RTRIM$(STR$(x))) + ".sav" FOR BINARY AS #fileno
   
   
   
   FOR a = 1 TO 3
      PUT #fileno, , players(a).sname
      PUT #fileno, , players(a).hp
      PUT #fileno, , players(a).maxhp
      PUT #fileno, , players(a).mp
      PUT #fileno, , players(a).maxmp
      PUT #fileno, , players(a).Experience
      PUT #fileno, , players(a).level
   NEXT a
   
   FOR a = 0 TO 170
      FOR b = 0 TO 170
         PUT #fileno, , map(a,b)
      NEXT b
   NEXT a
   
   FOR a = 0 TO 512
      PUT #fileno, , ScriptArraySpace(a)
   NEXT a
   
   FOR a = -100 TO 140
      FOR b = 1 TO 10
         PUT #fileno, , objects(a, b)
      NEXT b
   NEXT a
   
   PUT #fileno, , oldsy
   PUT #fileno, , CameraFocusSprite
   PUT #fileno, , bigmapx
   PUT #fileno, , bigmapy
   PUT #fileno, , walkspeed
   PUT #fileno, , debug
   PUT #fileno, , whatthefuck
   PUT #fileno, , pvpvarx
   PUT #fileno, , pvpvary
   PUT #fileno, , px
   PUT #fileno, , py
   PUT #fileno, , ar
   PUT #fileno, , ay
   PUT #fileno, , minimumpx
   PUT #fileno, , minimumpy
   PUT #fileno, , maxpx
   PUT #fileno, , maxpy
   PUT #fileno, , RAtimer
   PUT #fileno, , LAtimer
   PUT #fileno, , UAtimer
   PUT #fileno, , DAtimer
   PUT #fileno, , ScriptCalledFromSprite
   PUT #fileno, , VSyncActive
   PUT #fileno, , Focus
   PUT #fileno, , BackGroundFileName
   PUT #fileno, , ForeGroundFileName
   PUT #fileno, , UseJoystick
   PUT #fileno, , ObjectShadows
   PUT #fileno, , weather
   
   FOR a = 0 TO 30
      PUT #fileno, , itemlist(a).Objectname
      PUT #fileno, , itemlist(a).attributes
      PUT #fileno, , itemlist(a).Quantity
   NEXT a
   
   
   
   
   FOR a = 1 TO 3
      PUT #fileno, , players(a).hp
      PUT #fileno, , players(a).mp
      PUT #fileno, , players(a).maxhp
      PUT #fileno, , players(a).maxmp
      PUT #fileno, , players(a).time
      PUT #fileno, , players(a).speed
      PUT #fileno, , players(a).speedmod
      PUT #fileno, , players(a).attack
      PUT #fileno, , players(a).defence
      PUT #fileno, , players(a).dead
      PUT #fileno, , players(a).exists
      PUT #fileno, , players(a).sname
      
      PUT #fileno, , players(a).ready
      PUT #fileno, , players(a).Experience
      PUT #fileno, , players(a).level
      PUT #fileno, , players(a).gold
      PUT #fileno, , players(a).maxspells
      PUT #fileno, , players(a).sprite
   NEXT a
   FOR a = 1 TO 10
      FOR b = 1 TO 3
         PUT #fileno, , people(a).up(b)
         PUT #fileno, , people(a).down(b)
         PUT #fileno, , people(a).left(b)
         PUT #fileno, , people(a).right(b)
         PUT #fileno, , people(a).special(b)
      NEXT b
      PUT #fileno, , people(a).upbattle(1)
      PUT #fileno, , people(a).downbattle(1)
      PUT #fileno, , people(a).leftbattle(1)
      PUT #fileno, , people(a).rightbattle(1)
      PUT #fileno, , people(a).upslash(1)
      PUT #fileno, , people(a).downslash(1)
      PUT #fileno, , people(a).leftslash(1)
      PUT #fileno, , people(a).rightslash(1)
      
      PUT #fileno, , people(a).battleslash(1)
   NEXT a
   
   
	PUT #fileno, , CurrentMusic$
   
   CLOSE fileno
   
END SUB

SUB Script (BYVAL scriptno)
   addToDebug "Running Script " + STR$(scriptno)
   
   save 9
   addToDebug "saved"
   DIM fstart AS LONG
   DIM fend AS LONG
   DIM fileno2 AS INTEGER
   DIM button(4) AS INTEGER
   
   fileno2 = FREEFILE
   
   File$ = "script1"
   addToDebug "Pre-open script"
   OPEN File$ FOR INPUT SHARED AS #fileno2
   addToDebug "Post-open script"
   fstart = 0
   fend = 0
   'Finds the record first.
   WHILE com$ <> LTRIM$(RTRIM$(LCASE$("entry " + STR$(scriptno))))
      addToDebug "Reading... entry " + STR$(scriptno)
      INPUT #fileno2, com$
      addToDebug "Checking..."
      IF EOF(fileno2) THEN CLOSE #fileno2: EXIT SUB
      addToDebug com$+ str$(fstart)
      fstart = fstart + 1
   WEND
	addToDebug "Post record discovery"
	addToDebug "Starting at " + STR$(fstart)
	addToDebug com$
   
   
   
   
   com$ = ""
   'finds the end of the record.
   fend = fstart
   WHILE (GetParameter(com$, 1) <> "entry") AND (LTRIM$(RTRIM$(LCASE$(com$))) <> "end")
      INPUT #fileno2, com$
      IF EOF(fileno2) THEN CLOSE #fileno2: deinit
      fend = fend + 1
   WEND
   
	addToDebug "Ending at " + STR$(fend)
	addToDebug com$
	addToDebug "---"
   
   
   
   
   
   
   scriptRunReigon fstart, fend
   
END SUB

SUB scriptRunReigon (fstart AS LONG, fend AS LONG)
   
   '   SHARED bitmask()
   DIM Prt AS LONG
   
   
   
   skipthisframe = 1
   reimplemented = 0
   DIM otimer AS DOUBLE
   'SHARED EnemyCallInfo() AS EnemyCall
   
   DIM button(4) AS INTEGER
   
   fileno2 = FREEFILE
   
   File$ = "script1"
   
   OPEN File$ FOR INPUT SHARED AS #fileno2
   
	FOR a = 1 TO fstart
      INPUT #fileno2, com$
   NEXT a
   
   
   
   FOR FileRunPosition = fstart TO fend
      addToDebug STR$(FileRunPosition) + ":  " + com$
      SELECT CASE LCASE$(GetParameter$(com$, 1))
      CASE "giveitem"
         parm1$ = LCASE$(GetParameter$(com$, 2))
         parm2 = VAL(GetParameter$(com$, 3))
         
         itemadd parm1$, parm2'LCASE$(GetParameter$(com$, 2)), VAL(GetParameter$(com$, 3))
      case "night"
         Nightfall = 1
      case "day"
         Nightfall = 0
      CASE "startmenu"
         startmenu
      CASE "rain"
         weather = 1
      CASE "snow"
         weather = 2
      CASE "norain"
         weather = 0
         ParticlePurge
      CASE "runbeside"
         '(Spritenumber, Sprite2number, Shift)
         Spritenumber = players(VAL(GetParameter$(com$, 2))).sprite
         Sprite2number = players(VAL(GetParameter$(com$, 2)) - 1).sprite
         
         'linemove (Spritenumber, Sprite2number, Shift)
         sssss = Spritenumber
         IF Spritenumber >= 1 AND Spritenumber <= 3 THEN KKJ = Spritenumber
         IF Sprite2number >= 1 AND Sprite2number <= 3 THEN KKJ = Sprite2number
         
         DIM slopex AS SINGLE
         DIM slopey AS SINGLE
         
         DIM steps AS INTEGER
         DIM Xone AS INTEGER
         DIM Yone AS INTEGER
         DIM Xtwo AS INTEGER
         DIM Ytwo AS INTEGER
         
         Xone = (objects(Spritenumber, 1) * tilesize) + objects(Spritenumber, 4) - 40
         Yone = (objects(Spritenumber, 2) * tilesize) + objects(Spritenumber, 5)
         
         Xtwo = (objects(Sprite2number, 1) * tilesize) + objects(Sprite2number, 4)
         Ytwo = (objects(Sprite2number, 2) * tilesize) + objects(Sprite2number, 5) + Shift
         
         steps = (ABS(Xone - Xtwo) + ABS(Yone - Ytwo)) \ 10
         'steps = (((ABS(Xone - Xtwo) ^ 2) + (ABS(Yone - Ytwo) ^ 2)) ^ .5) * 2
         
         
         'Startx = Xone
         'starty = Yone
         slopex = (Xtwo - Xone) / steps
         slopey = (Ytwo - Yone) / steps
         
         
         'Startx = Xone
         'starty = Yone
         
         FOR a = 1 TO steps
            
            nocdmoveobject sssss, slopex, slopey
            IF players(KKJ).dead = False THEN
               objects(140 - KKJ, 1) = objects(KKJ, 1)
               objects(140 - KKJ, 2) = objects(KKJ, 2)
               objects(140 - KKJ, 3) = 44
               objects(140 - KKJ, 4) = objects(KKJ, 4)
               objects(140 - KKJ, 5) = objects(KKJ, 5)
               
            END IF
            
            
            fullredraw
            battlebox
            pageflip
            
            '   Startx = Startx + slopex
            '   starty = starty + slopey
         NEXT a
         
      CASE "objectshadows"
         
         setObjectShadow VAL(GetParameter$(com$, 2))
         
      CASE "playersprite"
         players(VAL(GetParameter$(com$, 2))).sprite = VAL(GetParameter$(com$, 3))
         
      CASE "focus"
         CameraFocus Focus
      CASE "fillall"
         FOR a = 1 TO 3
            players(a).hp = players(a).maxhp
            players(a).mp = players(a).maxmp
         NEXT a
      CASE "setexperience"
         
         
         players(VAL(GetParameter(com$, 2))).Experience = VAL(GetParameter(com$, 3))
         PlayersCalculate players()
         
         FOR a = 1 TO 3
            players(a).hp = players(a).maxhp
            players(a).mp = players(a).maxmp
         NEXT a
         
      CASE "setpeople"
         personno = VAL(GetParameter$(com$, 2))
         direction$ = LTRIM$(RTRIM$(GetParameter$(com$, 3)))
         
         frameno = VAL(GetParameter$(com$, 4))
         pvalue = VAL(GetParameter$(com$, 5))
         
         
         IF direction$ = "up" THEN
            people(personno).up(frameno) = pvalue
         END IF
         IF direction$ = "down" THEN
            people(personno).down(frameno) = pvalue
         END IF
         IF direction$ = "left" THEN
            people(personno).left(frameno) = pvalue
         END IF
         IF direction$ = "right" THEN
            people(personno).right(frameno) = pvalue
         END IF
         IF direction$ = "special" THEN
            people(personno).special(frameno) = pvalue
         END IF
         
         
         
         
      CASE "special"
         spritemovd = VAL(GetParameter$(com$, 2))
         
         objects(spritemovd, 3) = people(objects(spritemovd, 10)).special(1)
         
      CASE "faceup"
         spritemovd = VAL(GetParameter$(com$, 2))
         
         objects(spritemovd, 3) = people(objects(spritemovd, 10)).up(1)
      CASE "facedown"
         spritemovd = VAL(GetParameter$(com$, 2))
         
         objects(spritemovd, 3) = people(objects(spritemovd, 10)).down(1)
         
      CASE "faceleft"
         spritemovd = VAL(GetParameter$(com$, 2))
         
         objects(spritemovd, 3) = people(objects(spritemovd, 10)).left(1)
         
      CASE "faceright"
         spritemovd = VAL(GetParameter$(com$, 2))
         
         objects(spritemovd, 3) = people(objects(spritemovd, 10)).right(1)
         
         
         
      CASE "spriteundersprite"
         'SpriteUnderSprite mover target
         spritemovd = VAL(GetParameter$(com$, 2))
         
         target = VAL(GetParameter$(com$, 3))
         'Reminder of objects protocol:
         'MajorX, MajorY, sprite,  MinorX, MinorY, etc... :)
         'X
         objects(spritemovd, 1) = objects(target, 1)
         'Y
         objects(spritemovd, 2) = objects(target, 2) + 1
         
         
      CASE "paragraph"
         line1$ = ""
         line2$ = ""
         line3$ = ""
         line4$ = ""
         line5$ = ""
         
         
         
         'gets rid of the command from the text.
         com$ = MID$(com$, 11)
         
         'This changes "^"s into commas.
         
         FOR a = 1 TO LEN(com$)
            IF MID$(com$, a, 1) = "^" THEN
               b$ = b$ + ","
            ELSE
               b$ = b$ + MID$(com$, a, 1)
            END IF
         NEXT a
         
         
         com$ = b$
         b$ = ""
         
         calcrenderarea
         
         line1$ = wordwrap$(com$, 43)
         line2$ = wordwrap$(com$, 43)
         line3$ = wordwrap$(com$, 43)
         line4$ = wordwrap$(com$, 43)
         line5$ = wordwrap$(com$, 43)
         
         showText line1$ + " " + line2$ + " " + line3$ + " " + line4$ + " " + line5$, shadowdrop, allblend()
         
         textwait line1$, line2$, line3$, line4$, line5$, ObjectShadows, allblend()
         
         calcrenderarea
         everyfive = 0
         WHILE (com$ <> "")
            
            line1$ = line2$'wordwrap$(com$, 43)
            line2$ = line3$'wordwrap$(com$, 43)
            line3$ = line4$'wordwrap$(com$, 43)
            line4$ = line5$'wordwrap$(com$, 43)
            
            line5$ = wordwrap$(com$, 42)
            
            IF everyfive = 4 THEN line5$ = LTRIM$(RTRIM$(line5$)) + " ->"
            
            scrolText line1$, line2$, line3$, line4$, line5$
            
            
            everyfive = everyfive + 1
            
            IF everyfive = 5 THEN textwait line1$, line2$, line3$, line4$, line5$, ObjectShadows, allblend(): everyfive = 0
            
         WEND
         
         IF (everyfive > 1) AND (everyfive < 5) THEN textwait line1$, line2$, line3$, line4$, line5$, ObjectShadows, allblend()
      CASE "txtsleep"
         textwait line1$, line2$, line3$, line4$, line5$, ObjectShadows, allblend()
         line1$ = ""
         line2$ = ""
         line3$ = ""
         line4$ = ""
         line5$ = ""
         
         
      CASE "gradient"
		   r = VAL(GetParameter$(com$, 2))
		   g = VAL(GetParameter$(com$, 3))
		   b = VAL(GetParameter$(com$, 4))
         
         Getgrad r, g, b'A red gradient will be retrieved.
         
      CASE "player"
         players(VAL(GetParameter$(com$, 2))).sname = GetParameter$(com$, 3)
         
      CASE "script"
         command1 = VAL(GetParameter$(com$, 2))
         Script command1
      CASE "bool"'bool x = z
         ProgramErrorMessage = "Boolean Integer Script"
         Prt = VAL(GetParameter$(com$, 2))
         
         part = 0 + Prt / 15
         subpart = (Prt MOD 15) + 1
         
         value = VAL(GetParameter$(com$, 4))
         SetBinaryArray subpart, value, ScriptArraySpace(part)
         
      CASE "if"
         ProgramErrorMessage = "Choice Script"
         
         'if Part = 0/1 then (script X, end)
         
         Prt = VAL(GetParameter$(com$, 2))
         
         part = 0 + Prt / 15
         subpart = (Prt MOD 15) + 1
         
         bvalue = VAL(GetParameter$(com$, 4))
         command1$ = LCASE$(RTRIM$(LTRIM$(GetParameter$(com$, 6))))
         Command1B = VAL(GetParameter$(com$, 7))
         
         bvalue2 = 0
         'IF BinaryArray(subpart, ScriptArraySpace(part)) THEN Bvalue2 = 1 ELSE Bvalue2 = 0
         bvalue2 = ABS(BinaryArray(subpart, ScriptArraySpace(part))) = bvalue
         
         
         
         
         IF bvalue2 THEN
            IF LCASE$(LTRIM$(RTRIM$(command1$))) = "script" THEN Script Command1B: ConsoleMSG "Script" + STR$(Command1B)
            IF LCASE$(LTRIM$(RTRIM$(command1$))) = "end" THEN CLOSE fileno2: EXIT SUB
         END IF
         
         ConsoleMSG "IF encounter:" + STR$(part) + STR$(subpart) + STR$(BinaryArray(ScriptArraySpace(part), subpart))
         
         
         
      CASE "enemy"
         'This command is a thing of beauty. One command per enemy, and it sets it up.
         dim enemynumber
         Enemynumber = VAL(GetParameter$(com$, 2))
         Enemies(Enemynumber).sname = GetParameter$(com$, 3)
         Enemies(Enemynumber).sprite = VAL(GetParameter$(com$, 4))
         Enemies(Enemynumber).hp = VAL(GetParameter$(com$, 5))
         Enemies(Enemynumber).attack = VAL(GetParameter$(com$, 6))
         Enemies(Enemynumber).defence = VAL(GetParameter$(com$, 7))
         Enemies(Enemynumber).exists = VAL(GetParameter$(com$, 8))
         Enemies(Enemynumber).attacks = VAL(GetParameter$(com$, 9))
         Enemies(Enemynumber).speed = VAL(GetParameter$(com$, 10))
         Enemies(Enemynumber).gold = VAL(GetParameter$(com$, 11))
         
      CASE "chgme" 'Changes current script to X -- stays because of what it is.
         ConsoleMSG "Change me :" + STR$(ScriptCalledFromSprite) + MID$(com$, 6)
			obj = ScriptCalledFromSprite
         objects(obj, 6) = VAL(GetParameter$(com$, 2))
         
         ConsoleMSG "Result:" + STR$(objects(ScriptCalledFromSprite, 6))
         
         
      CASE "battle" 'The new battle system scripting command HOORAY
         healdivider = 0
         
         
         DataGet
         battle (Result)
         ConsoleMSG "Result:" + STR$(Result)
         
      CASE "pscrl"
         W = VAL(GetParameter$(com$, 2))
         x = VAL(GetParameter$(com$, 3))
         y = VAL(GetParameter$(com$, 4))
         Z = VAL(GetParameter$(com$, 5))
         
         pscroll W, x, y, Z
         
      CASE "stpal"
         x = VAL(GetParameter$(com$, 2))
         y = VAL(GetParameter$(com$, 3))
         Z = VAL(GetParameter$(com$, 4))
         
         spal x, y, Z
         
         
      CASE "focus"
         CameraFocus VAL(GetParameter(com$, 2))
         
      CASE "fulsp"
         TemporaryString$ = ".\pics\" + GetParameter$(com$, 2)
         fullscrpic TemporaryString$, page
      CASE "allscreenfullpic"
         
         TemporaryString$ = ".\pics\" + GetParameter$(com$, 2)
         fullscrpic TemporaryString$, 0
         
      CASE "objset"'Direct setting of the objects array. cool, eh?
         parm1 = VAL(GetParameter$(com$, 2))
         parm2 = VAL(GetParameter$(com$, 3))
         parm3 = VAL(GetParameter$(com$, 4))
         objects(parm1, parm2) = parm3
         ConsoleMSG "Obj set" + STR$(parm1) + STR$(parm2) + STR$(parm3)
         
      CASE "steps"
         steps = VAL(MID$(com$, 6))
      CASE "dualmove" 'The nextgen movement command. See?
         
         mobj = VAL(GetParameter(com$, 2))
         mobj2 = VAL(GetParameter(com$, 3))
         
         
         msteps = VAL(GetParameter(com$, 4))
         mXsteps = VAL(GetParameter(com$, 5))
         mYsteps = VAL(GetParameter(com$, 6))
         FOR loopy = 1 TO msteps
            nocdmoveobject mobj, mXsteps, mYsteps
            nocdmoveobject mobj2, mXsteps, mYsteps
            
            
            IF mobj = Focus THEN CameraFocus (Focus)
            calcrenderarea
            drawall
            '  IF ObjectShadows = 1 THEN RenderObjectShadows
            renderobjects
            particleWeather
            
            pageflip
         NEXT loopy
         
         
      CASE "move" 'The nextgen movement command. See?
         
         mobj = VAL(GetParameter(com$, 2))
         msteps = VAL(GetParameter(com$, 3))
         mXsteps = VAL(GetParameter(com$, 4))
         mYsteps = VAL(GetParameter(com$, 5))
         FOR loopy = 1 TO msteps
            nocdmoveobject mobj, mXsteps, mYsteps
            IF mobj = Focus THEN CameraFocus (Focus)
            calcrenderarea
            drawall
            '  IF ObjectShadows = 1 THEN RenderObjectShadows
            renderobjects
            particleWeather
            
            pageflip
         NEXT loopy
         
      CASE "chfile"
         pscroll -2, -2, -2, 32
         fileread 1, VAL(LTRIM$(RTRIM$(GetParameter(com$, 2))))
         CameraFocus 1
         calcrenderarea
         drawall
         '       IF ObjectShadows = 1 THEN RenderObjectShadows
         renderobjects
			particleWeather
         
         pageflip
      CASE "pvpx"
			pvpvarx = -(VAL(GetParameter(com$, 2)))
         
      CASE "pvpy"
			pvpvary = -(VAL(MID$(com$, 5)))
         
      CASE "pminx"
         
			minimumpx = -(VAL(MID$(com$, 6)))
      CASE "pminy"
         
			minimumpy = -(VAL(MID$(com$, 6)))
      CASE "pmaxx"
         
			maxpx = -(VAL(MID$(com$, 6)))
      CASE "pmaxy"
         
			maxpy = -(VAL(MID$(com$, 6)))
      CASE "drawall"
         calcrenderarea
			drawall
         '   IF ObjectShadows = 1 THEN RenderObjectShadows
			renderobjects
			particleWeather
         
			pageflip
      CASE "sleep"
		   ctrlslp
         
      CASE "music"
			'This is another one which needs to have fixed length.
			'StopMidi
         RunningMIDI = winmmStopMidi( ) 
         RunningMidi = winmmPlayMidi(".\music\" + LTRIM$(RTRIM$(MID$(com$, 6))))
         
			'Filename$ = 
         
			'playMidi Filename$
         
      CASE "pause"
         otimer = TIMER
         lin = VAL(MID$(com$, 6))
         WHILE TIMER < otimer + lin: WEND
      END SELECT
      
      INPUT #fileno2, com$
   NEXT FileRunPosition
   CLOSE fileno2
   EXIT SUB
   
END SUB

SUB scrolText (line1$, line2$, line3$, line4$, line5$)
   
   
   DIM buttons(4) AS INTEGER
   
   
   DIM oldtimer AS SINGLE
   
   'showpage page
   
   DIM sEmpty AS STRING
   DIM waittime AS INTEGER
   waittime = 2
   
   
   a = 1
   '   FOR a = 1 TO LEN(line5$)
   WHILE a <= LEN(line5$)
      
		pageflip
		MoveWater
		MoveTransition
		drawall
      '      IF ObjectShadows = 1 THEN RenderObjectShadows
		renderobjects
		particleWeather
      
      omaGetScreenDimensions w, h 
      battlebox
		
      shadowdrop = 1
      sprint 14, line1$, 16
		shadowdrop = 0
      sprint 14, line1$, 0
		shadowdrop = 1
      sprint 15, line2$, 16
		shadowdrop = 0
      sprint 15, line2$, 0
		shadowdrop = 1
      sprint 16, line3$, 16
		shadowdrop = 0
      sprint 16, line3$, 0
		shadowdrop = 1
      sprint 17, line4$, 16
		shadowdrop = 0
      sprint 17, line4$, 0
      sEmpty = MID$(line5$, 1, a)
      
		shadowdrop = 1
      
      sprint 18, sEmpty, 16
      
		shadowdrop = 0
      
      sprint 18, sEmpty, 0
      
      waiter = 0: a = a + 5
   WEND
   
END SUB

SUB SelfCalibrate ()
   
   'a = STICK(0)
   IF a = 0 THEN UseJoystick = 0
   
   IF UseJoystick = 1 THEN
      FOR a = 1 TO 50
         DirectStick JoyX, JoyY, S, S, S, S
         
         
         JconstantX = JconstantX + JoyX
         JconstantY = JconstantY + JoyY
      NEXT a
      
      JconstantX = JconstantX \ 50
      JconstantY = JconstantY \ 50
      
   END IF
   
END SUB

SUB SetBinaryArray (Arrayno, figure, Variable)
   
	position = 2 ^ (Arrayno - 1)
   IF figure <> 0 THEN
		Variable = (Variable XOR position) OR position
   ELSE
		Variable = Variable AND (32767 XOR position)
   END IF
   
   
END SUB

SUB setObjectShadow (x)
   ObjectShadows = x
   
END SUB

SUB showSpells (row, playa AS INTEGER, CurrentDisplay AS INTEGER, t AS INTEGER)
   
   DIM lines(1 TO 5) AS STRING
   CurrentDisplay = ((t - 1) \ 5) * 5 'Making CurrentDisplay obsolete through math.
   
   'IF CurrentDisplay < 0 THEN CurrentDisplay = 0
   FOR a = 1 TO 5
      lines(a) = MagicName(playa, CurrentDisplay + a)
      IF lines(a) = "Out of Bounds" THEN lines(a) = ""
   NEXT a
   FOR a = 1 TO 5
      shadowdrop = 1
      sprint 13 + a + row, lines(a), 16
      shadowdrop = 0
      IF CurrentDisplay + a = t THEN cl = 2 ELSE cl = 0
      sprint 13 + a, lines(a), cl
   NEXT a
   
END SUB

SUB showText (words$, shadowdrop, allblend())
   pageflip
   DIM line1$, line2$, line3$, line4$, line5$
   
	line1$ = wordwrap$(words$, 43)
	line2$ = wordwrap$(words$, 43)
	line3$ = wordwrap$(words$, 43)
	line4$ = wordwrap$(words$, 43)
	line5$ = wordwrap$(words$, 43)
	DIM buttons(4) AS INTEGER
   
   
	DIM oldtimer AS SINGLE
   
	DIM sEmpty AS STRING
	DIM waittime AS DOUBLE
   
   
   a = 1
   WHILE a <= LEN(line1$)
      
		pageflip
		MoveWater
		MoveTransition
		drawall
		'IF ObjectShadows = 1 THEN RenderObjectShadows
		renderobjects
		particleWeather
      
		battlebox
      
      sEmpty = MID$(line1$, 1, a)
      
		shadowdrop = 1
      
      sprint 14, sEmpty, 16
      
		shadowdrop = 0
      
      sprint 14, sEmpty, 0
      
      waiter = 0: a = a + 3
   WEND
   
   a = 1
   WHILE a <= LEN(line2$)
      
		pageflip
		MoveWater
		MoveTransition
		drawall
		'IF ObjectShadows = 1  THEN RenderObjectShadows
		renderobjects
		particleWeather
      
      battlebox
      
      shadowdrop = 1
      sprint 14, line1$, 16
		shadowdrop = 0
      sprint 14, line1$, 0
      sEmpty = MID$(line2$, 1, a)
      
		shadowdrop = 1
      
      sprint 15, sEmpty, 16
      
		shadowdrop = 0
      
      sprint 15, sEmpty, 0
      
      waiter = 0: a = a + 3
      
   WEND
   
   a = 1
   WHILE a <= LEN(line3$)
		IF waiter >= waittime THEN a = a + 1: waiter = 0
		waiter = waiter + 1
      
		pageflip
		MoveWater
		MoveTransition
		drawall
		'IF ObjectShadows = 1 THEN RenderObjectShadows
		renderobjects
		particleWeather
      
      battlebox
      
      shadowdrop = 1
      sprint 14, line1$, 16
		shadowdrop = 0
      sprint 14, line1$, 0
		shadowdrop = 1
      sprint 15, line2$, 16
		shadowdrop = 0
      sprint 15, line2$, 0
      sEmpty = MID$(line3$, 1, a)
      
		shadowdrop = 1
      
      sprint 16, sEmpty, 16
      
		shadowdrop = 0
      
      sprint 16, sEmpty, 0
      
      digitalJstk dummy, dummy, dummy, dummy, buttons()
      
      i = GetSingleKey
      waiter = 0: a = a + 3
      
   WEND
   
   a = 1
   WHILE a <= LEN(line4$)
		IF waiter >= waittime THEN a = a + 1: waiter = 0
		waiter = waiter + 1
      
		pageflip
		MoveWater
		MoveTransition
		drawall
		'IF ObjectShadows = 1 THEN RenderObjectShadows
		renderobjects
		particleWeather
      
      battlebox
      shadowdrop = 1
      sprint 14, line1$, 16
		shadowdrop = 0
      sprint 14, line1$, 0
		shadowdrop = 1
      sprint 15, line2$, 16
		shadowdrop = 0
      sprint 15, line2$, 0
		shadowdrop = 1
      sprint 16, line3$, 16
		shadowdrop = 0
      sprint 16, line3$, 0
      sEmpty = MID$(line4$, 1, a)
      
		shadowdrop = 1
      
      sprint 17, sEmpty, 16
      
		shadowdrop = 0
      
      sprint 17, sEmpty, 0
      
      waiter = 0: a = a + 3
      
   WEND
   
   
   a = 1
   WHILE a <= LEN(line5$)
		IF waiter >= waittime THEN a = a + 1: waiter = 0
		waiter = waiter + 1
      
		pageflip
		MoveWater
		MoveTransition
		drawall
		'IF ObjectShadows = 1 THEN RenderObjectShadows
		renderobjects
		particleWeather
      
		battlebox
		shadowdrop = 1
      sprint 14, line1$, 16
		shadowdrop = 0
      sprint 14, line1$, 0
		shadowdrop = 1
      sprint 15, line2$, 16
		shadowdrop = 0
      sprint 15, line2$, 0
		shadowdrop = 1
      sprint 16, line3$, 16
		shadowdrop = 0
      sprint 16, line3$, 0
		shadowdrop = 1
      sprint 17, line4$, 16
		shadowdrop = 0
      sprint 17, line4$, 0
      sEmpty = MID$(line5$, 1, a)
      
		shadowdrop = 1
      
      sprint 18, sEmpty, 16
      
		shadowdrop = 0
      
      sprint 18, sEmpty, 0
      
      waiter = 0: a = a + 3
      
   WEND
   
   
END SUB

SUB sortobjects () 'this subroutine sorts the objects on the screenSurface.
   
   
   DIM here AS INTEGER
   here = 4
   FOR a = 136 TO -100 STEP -1
      'IF a = 4 THEN a = 0
      
      IF objects(a, 3) > 0 AND objects(a, 3) <> 50 THEN 'These don't get included.
         IF objects(a, 1) >= RenderFirstX AND objects(a, 2) >= RenderFirstY THEN
            IF objects(a, 1) <= RenderSecondX AND objects(a, 2) <= RenderSecondY THEN
               ObjectBuffer(here, 1) = a
               IF objects(a, 2) <= objects(1, 2) THEN
                  ObjectBuffer(here, 2) = 1
                  
                  here = here + 1
               ELSE
                  ObjectBuffer(here, 2) = 2
                  here = here + 1
               END IF
            END IF
         END IF
      END IF
   NEXT a
   
   'It writes the final object (which is always the last drawn), then the pNULL.
   ObjectBuffer(here, 1) = 137
   ObjectBuffer(here, 2) = 2
   ObjectBuffer(here + 1, 1) = 256
   
END SUB

SUB spal (r, g, b)
   'FIXME: IMPLEMENT PALETTE SCROLLING!!!
END SUB

SUB sprint (row, text$, colr)
   text$ = LEFT$(text$, 45)
   
   
   IF colr = 1 THEN colr = 31
   IF colr = 0 THEN colr = 31
   
   
   
   
'	CachedMultiplication = row * 12
	
   omaGetScreenDimensions w, h 
   CachedMultiplication = ((row - 14)* 12) + (h / 4) + 50
   
   shadowdrop = 1
	xsprint CachedMultiplication, 0, text$, 16
	shadowdrop = 0
	xsprint CachedMultiplication, 0, text$, colr
   
   
END SUB

SUB startmenu () 'suprisingly, this isn't a sad attempt to copy a MS trademark.
   dim notchosen, i, menuchoice ,didntchoose, waiting
   notchosen = -1
   WHILE (notchosen)
      i = 0
      i = GetSingleKey 
      
      
      SELECT CASE i
      CASE Uparrow
         menuchoice = menuchoice - 1
      CASE Dnarrow
         menuchoice = menuchoice + 1
      CASE spacebar
         notchosen = False
      END SELECT
      
      'multikey 57, keycoden
      'IF keycoden THEN script 1: EXIT SUB
      
      
      IF menuchoice > 3 THEN menuchoice = 0
      
      IF menuchoice < 0 THEN menuchoice = 3
      xsprint 135, 125, "Start", (2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
      xsprint 150, 127, "Load", (2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
      xsprint 165, 115, "Controls", (2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 2))
      xsprint 180, 127, "Exit", (2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
      pageflip
      
      
   WEND
   
   IF menuchoice = 0 THEN Xcls 0: Xcls 1: Xcls 2: Script 1
   IF menuchoice = 1 THEN
      didntchoose = 0
      menuchoice = 0
      notchosen = -1'true
      '  WHILE NOT (INP(90) AND 128): WEND
      WHILE (notchosen)
         
         xsprint 135, 125, "Start", 19'(2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
         xsprint 150, 127, "Load", 2'(2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
         xsprint 165, 115, "Controls", 19'(2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 2))
         xsprint 180, 127, "Exit", 19'(2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 3))
         xsprint 135, 175, "Game 0", (2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
         xsprint 150, 175, "Game 1", (2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
         xsprint 165, 175, "Game 2", (2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 2))
         xsprint 180, 175, "Game 3", (2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
         xsprint 195, 175, "Game 4", (2 * -(menuchoice = 4)) + (19 * -(menuchoice <> 4))
         pageflip
         
         'MTKInkey key$
         i= GetSingleKey
         SELECT CASE i
         CASE Uparrow
            menuchoice = menuchoice - 1
         CASE Dnarrow
            menuchoice = menuchoice + 1
         CASE sdlk_space
            notchosen = False
         CASE sdlk_escape
            xsprint 135, 175, "Game 0", 16' (2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
            xsprint 150, 175, "Game 1", 16' (2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
            xsprint 165, 175, "Game 2", 16' (2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 2))
            xsprint 180, 175, "Game 3", 16'(2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
            xsprint 195, 175, "Game 4", 16'(2 * -(menuchoice = 4)) + (19 * -(menuchoice <> 4))
            pageflip
            xsprint 135, 175, "Game 0", 16' (2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
            xsprint 150, 175, "Game 1", 16' (2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
            xsprint 165, 175, "Game 2", 16' (2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 2))
            xsprint 180, 175, "Game 3", 16'(2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
            xsprint 195, 175, "Game 4", 16'(2 * -(menuchoice = 4)) + (19 * -(menuchoice <> 4))
            pageflip
            xsprint 135, 175, "Game 0", 16' (2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
            xsprint 150, 175, "Game 1", 16' (2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
            xsprint 165, 175, "Game 2", 16' (2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 2))
            xsprint 180, 175, "Game 3", 16'(2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
            xsprint 195, 175, "Game 4", 16'(2 * -(menuchoice = 4)) + (19 * -(menuchoice <> 4))
            
            didntchoose = 1: notchosen = False
         END SELECT
         IF menuchoice > 4 THEN menuchoice = 0
         
         IF menuchoice < 0 THEN menuchoice = 4
         
         
         
      WEND
      
      IF didntchoose = 0 THEN gLOAD menuchoice ELSE startmenu: EXIT SUB
      
      
   END IF
   
   IF menuchoice = 2 THEN
      waiting = 0
      
      WHILE (NOT waiting)
         xsprint 135, 125, "Start", 16'(2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
         xsprint 150, 127, "Load", 16'(2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
         xsprint 165, 115, "Controls", 16'(2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 2))
         xsprint 180, 127, "Exit", 16'(2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 3))
         xsprint 135, 15, "Arrow Keys:Movement", 31' (2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
         xsprint 150, 15, "Spacebar:Activate", 31' (2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
         xsprint 165, 15, "Backspace:Cancel(battles only)", 31' (2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 2))
         xsprint 180, 15, "Escape:Menu/cancel menu", 31' (2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
         xsprint 195, 15, "Press Any Key.", 31' (2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
         
         
         pageflip
         
         waiting = GetSingleKey
         
      WEND
      
      xsprint 135, 15, "Arrow Keys:Movement", 0' (2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
      xsprint 150, 15, "Spacebar:Activate", 0' (2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
      xsprint 165, 15, "Backspace:Cancel(battles only)", 0' (2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 2))
      xsprint 180, 15, "Escape:Menu/cancel menu", 0' (2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
      xsprint 195, 15, "Press Any Key.", 16'31' (2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
      
      
      pageflip
      xsprint 135, 15, "Arrow Keys:Movement", 0' (2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
      xsprint 150, 15, "Spacebar:Activate", 0' (2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
      xsprint 165, 15, "Backspace:Cancel(battles only)", 0' (2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 2))
      xsprint 180, 15, "Escape:Menu/cancel menu", 0' (2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
      xsprint 195, 15, "Press Any Key.", 16'31' (2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
      
      
      pageflip
      xsprint 135, 15, "Arrow Keys:Movement", 0' (2 * -(menuchoice = 0)) + (19 * -(menuchoice <> 0))
      xsprint 150, 15, "Spacebar:Activate", 0' (2 * -(menuchoice = 1)) + (19 * -(menuchoice <> 1))
      xsprint 165, 15, "Backspace:Cancel(battles only)", 0' (2 * -(menuchoice = 2)) + (19 * -(menuchoice <> 2))
      xsprint 180, 15, "Escape:Menu/cancel menu", 0' (2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
      xsprint 195, 15, "Press Any Key.", 16'31' (2 * -(menuchoice = 3)) + (19 * -(menuchoice <> 3))
      
      
      
      
   END IF
   IF menuchoice = 2 THEN startmenu: EXIT SUB
   IF menuchoice = 3 THEN deinit
   
   
end sub

SUB statsint ()
   
   FOR drpshd = 1 TO 0 STEP -1
      shadowdrop = drpshd
      
      FOR Z = 1 TO 3
         IF players(Z).exists = True THEN
            IF players(Z).ready = True THEN
               xsprint 192 + (12 * (Z - 1)), 220, "M:" + LTRIM$(RTRIM$(STR$(players(Z).mp) + "/" + STR$(players(1).maxmp))), 2 * ABS(drpshd - 1)
            ELSE
               drawgraph 220, 192 + (12 * (Z - 1)), 90, 150, players(Z).time, 16, 2 * ABS(drpshd - 1)
               
            END IF
         END IF
      NEXT Z
   NEXT drpshd
   
END SUB

SUB textwait (line1$, line2$, line3$, line4$, line5$, ObjectShadows, allblend())
	
   DIM button(4) AS INTEGER
   
   
	'This waits until you release the button before asking if you've
	'pressed the button. :)
   
	waiting = 1
   
	'This will wait under all circumstances.
   
	WHILE (waiting)
      
      i = getsinglekey 
      if i = spacebar then waiting = 0
      
      
		pageflip
		MoveWater
		MoveTransition
		drawall
		'IF ObjectShadows = 1 THEN RenderObjectShadows
		renderobjects
		particleWeather
      
		battlebox
		shadowdrop = 1
      sprint 14, line1$, 16
		shadowdrop = 0
      sprint 14, line1$, 0
		shadowdrop = 1
      sprint 15, line2$, 16
		shadowdrop = 0
      sprint 15, line2$, 0
		shadowdrop = 1
      sprint 16, line3$, 16
		shadowdrop = 0
      sprint 16, line3$, 0
		shadowdrop = 1
      sprint 17, line4$, 16
		shadowdrop = 0
      sprint 17, line4$, 0
		shadowdrop = 1
      sprint 18, line5$, 16
		shadowdrop = 0
      sprint 18, line5$, 0
      
      
      
      
   WEND
   
	'it's crazy, but it works, so it's not crazy.
   
   
END SUB

SUB transbox (byval firstx, byval lastx,byval  FirstY,byval  lasty)
   'This horribly coded hack does the alpha effect of the original QFAK textbox.
   'I'd like to replace it with a PNG later.
   dim ShittyRect as SDL_Rect
   Dim ShittySurface as SDL_Surface ptr
   dim ConvertedFile as SDL_Surface ptr
   
   shittyrect.w = (lastx - firstx) * 2
   shittyrect.h = (lasty - firsty) * 2
   
   ShittySurface = SDL_CreateRGBSurface( SDL_SRCALPHA, shittyrect.w + 2, shittyrect.h, 32, 0, 0, 0, 0)
   ConvertedFile = SDL_DisplayFormat(ShittySurface)     
   omaKillSurface ShittySurface
   SDL_SetAlpha ConvertedFile, SDL_SRCALPHA, 128
   omaBlitImage firstx * 2 - 1, firsty * 2, Convertedfile
   omaKillSurface Convertedfile
   
   
END SUB

SUB TurnNumlockOff ()
END SUB

SUB UpdateDebug ()
END SUB

FUNCTION wordwrap$ (xline$, length)
   xline$ = xline$ + " "
   a = LEN(xline$)
   WHILE a > length OR MID$(xline$, a, 1) <> " "
      a = a - 1
   WEND
   
   oline$ = LEFT$(xline$, a)
   xline$ = MID$(xline$, a)
   xline$ = LTRIM$(RTRIM$(xline$))
   
   wordwrap$ = oline$
   
END FUNCTION

SUB Xcls (pag)
   FOR a = 1 TO 320
      FOR b = 1 TO 240
         PSET8bit a, b, 16
      NEXT b
   NEXT a
END SUB

function ggetkey$
   static oldx
   x = getsingleKey ()
   if x = 0 then ggetkey$ = "":exit function
   ggetKey$ = chr$(x AND 255)
   oldx = x
end function

SUB xsprint (row, column, text$, colr)
   
   IF row < 0 THEN row = 0
   row2 = (row) + shadowdrop
   
   'clength = 0
   DIM sy AS INTEGER
   DIM letternumber AS INTEGER
   DIM thiscolor AS INTEGER
   rea = shadowdrop + column
   FOR a = 1 TO LEN(text$)
      '  clength = clength + 7
      letternumber = ASC(isolate$(text$, a))
      IF letternumber > 96 AND letternumber < 123 THEN
			letternumber = letternumber - 32
      END IF
      IF letternumber < 33 OR letternumber > 90 THEN
         letternumber = 32
      END IF
      FOR b = 1 TO 6
         FOR c = 0 TO 8
            thiscolor = BinaryArray(c + 1, (charsprites(b, letternumber)))
            pusher = a * 7
            IF thiscolor THEN PSET8bit column + pusher + b, row2 + c, colr	NEXT c, b, a
            
         END SUB
         sub showpage (temp%)
            pageflip
         end sub
         sub PageFlip
            omaPageFlip()
            end sub